SystemOrganization addCategory: #'Math-RealInterval'!
SystemOrganization addCategory: 'Math-RealInterval-Algos'!
SystemOrganization addCategory: 'Math-RealInterval-Basic'!
SystemOrganization addCategory: 'Math-RealInterval-Setting'!
SystemOrganization addCategory: 'Math-RealInterval-utils'!

!Number methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 12/4/2014 14:44'!
difference: aNumberOrInterval 
^(RealInterval fromNumber: self)difference: aNumberOrInterval! !

!Number methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 3/1/2015 09:07'!
hull 
^RealInterval fromNumber: self! !

!Number methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 2/27/2015 14:18'!
hull: aNumberOrInterval 
^self isInfinite 
	ifTrue: [ (aNumberOrInterval isRealInterval or:[aNumberOrInterval isIntervalUnion ]) 
		ifTrue: [ aNumberOrInterval hull:self ] 
		ifFalse:[ RealInterval inf: (aNumberOrInterval min:self) sup: (aNumberOrInterval max: self)]  ] 	ifFalse:[(RealInterval fromNumber: self)hull: aNumberOrInterval]! !

!Number methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 1/15/2015 14:09'!
intersection: aNumberOrInterval 
^(aNumberOrInterval isRealInterval or:[aNumberOrInterval isIntervalUnion ])
	ifTrue: [ aNumberOrInterval intersection: self ] 
	ifFalse: [ self = aNumberOrInterval 
		ifTrue: [ self ] 
		ifFalse: [RealInterval new ] ]! !

!Number methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 12/21/2014 11:43'!
isAnInteger
^false! !

!Number methodsFor: '*Math-RealInterval' stamp: 'WernerKassens 6/7/2017 00:22'!
max: anObject 
^(anObject isKindOf: Magnitude)  ifTrue: [ super max: anObject ] ifFalse: [ anObject adaptToNumber: self andSend: #max: ]! !

!Number methodsFor: '*Math-RealInterval' stamp: 'WernerKassens 6/7/2017 00:23'!
min: anObject 
^(anObject isKindOf: Magnitude)  ifTrue: [ super min: anObject ] ifFalse: [ anObject adaptToNumber: self andSend: #min: ]! !

!Number methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 11/26/2014 12:21'!
union: aNumberOrInterval 
^(RealInterval fromNumber: self)union:aNumberOrInterval! !

RBTransformationRule subclass: #RuleAddTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Setting'!

!RuleAddTest commentStamp: 'WernerKassens 6/13/2017 18:41' prior: 0!
adds
(argument isRealInterval or: [ argument isIntervalUnion ])
	ifTrue: [ ^ argument adaptToNumber: self andSend: selector]!

!RuleAddTest class methodsFor: 'testing' stamp: 'WernerKassens 6/13/2017 15:24'!
isVisible
^false! !

!RuleAddTest methodsFor: 'running' stamp: 'WernerKassens 6/14/2017 04:39'!
checkMethod: aMethod
	| arg |
	arg := aMethod argumentNames first asString.
	self initialize.
	self rewriteRule
		replace:
			'| ``@temporaries1 |
			`.@Statement'
		with:
			('| ``@temporaries1 |
		({1} isRealInterval or: [ {1} isIntervalUnion ])
	ifTrue: [ ^ {1} adaptToNumber: self andSend: #{2}].
	`.@Statement'
				format: {arg. aMethod selector}).
	^ super checkMethod: aMethod! !

RBTransformationRule subclass: #RuleDeleteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Setting'!

!RuleDeleteTest commentStamp: 'WernerKassens 6/13/2017 14:21' prior: 0!
deletes 
(`aNumber isRealInterval or: [ `aNumber isIntervalUnion ])
	ifTrue: `@block.!

!RuleDeleteTest class methodsFor: 'testing' stamp: 'WernerKassens 6/13/2017 14:48'!
isVisible
^false! !

!RuleDeleteTest methodsFor: 'initialization' stamp: 'WernerKassens 6/14/2017 04:37'!
initialize
	super initialize.
	self rewriteRule
		replace:
			'| ``@temporaries1 |
			(`aNumber isRealInterval or: [ `aNumber isIntervalUnion ])
	ifTrue: `@block.
	`.@Statement'
		with: '| ``@temporaries1 |
		`.@Statement'
				! !

RBTransformationRule subclass: #RuleReplaceEqual0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Setting'!

!RuleReplaceEqual0 commentStamp: 'wernerkassens 9/15/2017 18:29' prior: 0!
replaces `variable1 = 0  or  0.0
by  `variable1 isZero!

!RuleReplaceEqual0 class methodsFor: 'testing' stamp: 'WernerKassens 6/13/2017 15:01'!
isVisible
^false! !

!RuleReplaceEqual0 methodsFor: 'initialization' stamp: 'WernerKassens 9/17/2017 13:37'!
initialize
	super initialize.
	self rewriteRule
		replace: '`aNumber = 0 ifTrue: `@block.
			`@.statements.'
			with: 'self flag:0.
			`aNumber isZero ifTrue: `@block.
			`@.statements.';
		replace: '`aNumber = 0.0 ifTrue: `@block'
			with: '`aNumber isZero ifTrue: `@block'! !

RBTransformationRule subclass: #RuleReplaceIsZero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Setting'!

!RuleReplaceIsZero commentStamp: 'WernerKassens 6/10/2017 18:39' prior: 0!
replaces `variable1 isZero
by `variable1 = 0!

!RuleReplaceIsZero class methodsFor: 'testing' stamp: 'WernerKassens 6/13/2017 14:50'!
isVisible
^false! !

!RuleReplaceIsZero methodsFor: 'initialization' stamp: 'WernerKassens 9/17/2017 13:44'!
initialize
	super initialize.
	self rewriteRule
		replace:
			'self flag: 0.
			`aNumber isZero ifTrue: `@block.
			`@.statements.'
		with: '`aNumber = 0 ifTrue: `@block.
		`@.statements.';
		replace:
			'`aNumber isZero
	ifTrue: `@block'
		with: '`aNumber = 0.0
	ifTrue: `@block'
				! !

Array variableSubclass: #IntervalBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Basic'!

!IntervalBox commentStamp: 'wernerkassens 2/12/2015 18:36' prior: 0!
An IntervalBox is simply an Array of Intervals or IntervalUnions that can be splitted and has several other convenience methods. hence it is used as an interval-vector for vector functions in the algos.
it is conceptually different from IntervallUnion insofar as IntervallUnion is one - dimensional whereas IntervalBox is multi - dimensional. 
!

!IntervalBox class methodsFor: 'instance creation' stamp: 'wernerkassens 2/12/2015 18:32'!
new: anInt 
^(super new: anInt) atAllPut: RealInterval new    ! !

!IntervalBox methodsFor: 'converting' stamp: 'wernerkassens 3/17/2015 13:25'!
asSimpleBoxes
"returns an OrderedCollection of Boxes that consist only of RealIntervals"
|oc|
oc :=OrderedCollection with: self.
1 to: self size do:[:index|
oc:=oc flatCollect: [ :ibox|
(ibox at: index) isIntervalUnion 
	ifTrue: [(ibox at:index)collect:[:j| |x|
		x:=ibox copy.
		x at:index put:j. x]]
	ifFalse:[{ibox}]]].
^oc! !

!IntervalBox methodsFor: 'accessing' stamp: 'wernerkassens 2/12/2015 21:58'!
at: anInteger put: anObject 
^anObject isNumber 
	ifTrue: [ super at: anInteger  put: (RealInterval fromNumber: anObject) ] 
	ifFalse:[super at: anInteger  put:anObject ] ! !

!IntervalBox methodsFor: 'copying' stamp: 'wernerkassens 1/15/2015 17:39'!
copy 
^self collect:[:i|i copy].! !

!IntervalBox methodsFor: 'converting' stamp: 'WernerKassens 2/22/2016 19:02'!
enlargeToWidth: aNumber
self do:[:i|i enlargeToWidth:aNumber] ! !

!IntervalBox methodsFor: 'set operations' stamp: 'wernerkassens 2/16/2015 16:51'!
hull
^self collect:[:i|i hull]! !

!IntervalBox methodsFor: 'set operations' stamp: 'wernerkassens 2/16/2015 17:00'!
hull: anIntervalBox
^self with: anIntervalBox collect:[:i :j|(i union: j) hull]! !

!IntervalBox methodsFor: 'testing' stamp: 'wernerkassens 2/11/2015 16:32'!
includes: aBox
self with: aBox do:  [ :int :int2|(int includes: int2)ifFalse:[^false]].
^true! !

!IntervalBox methodsFor: 'accessing' stamp: 'wernerkassens 2/11/2015 23:22'!
inf
^self collect: [ :i|i inf ]as:Array! !

!IntervalBox methodsFor: 'testing' stamp: 'wernerkassens 3/23/2015 08:42'!
isEmpty 
^self size = 0 or: [self anySatisfy: [:i|i isEmpty]].
! !

!IntervalBox methodsFor: 'accessing' stamp: 'wernerkassens 2/27/2015 12:31'!
maxWidthDimension
|d max m|
max := 0.
d := 1 min: self size.
1 to: self size do: [ :i|
	m:= (self at:i) width.
	m > max ifTrue: [max:=m. d:=i]].
^d! !

!IntervalBox methodsFor: 'accessing' stamp: 'wernerkassens 3/19/2015 15:01'!
midPoint
^self collect: [ :i|i midPoint ]as:Array! !

!IntervalBox methodsFor: 'set operations' stamp: 'WernerKassens 2/21/2016 14:11'!
quasiUnion: anIntervalBox
"is something between a union and a hull, is necessary for skelboemoore, but a real union: would be better instead, but then the output would become very complicated occasionally!! ill keep it like that for the moment, as one can shut off the simplification in skelboemoore by setting useSloppySimplification to false"
"i also noticed that one occasionaly wants to use #includes: and the normal set operations. perhaps should be implemented"
^self with: anIntervalBox collect:[:ivl1 :ivl2| ivl1 union: ivl2 ] 
! !

!IntervalBox methodsFor: 'converting' stamp: 'WernerKassens 2/18/2016 17:34'!
split
|d i cp|
d:= self maxWidthDimension .
i:=self at: d.
(i:= i split: i cutPoint) ifNil: [ ^nil ].
cp:= Array with: self copy with: self copy.
(cp at:1)at:d put: (i at:1).
(cp at:2)at:d put: (i at:2).
^cp
! !

!IntervalBox methodsFor: 'arithmetic' stamp: 'wernerkassens 3/24/2015 11:52'!
squared
	^ self collect: [:each | each squared ]! !

!IntervalBox methodsFor: 'arithmetic' stamp: 'wernerkassens 3/24/2015 11:51'!
sum 
^self reduce: [ :a :b | a + b ]! !

!IntervalBox methodsFor: 'accessing' stamp: 'wernerkassens 2/11/2015 23:22'!
sup
^self collect: [ :i|i sup ]as:Array! !

!IntervalBox methodsFor: 'accessing' stamp: 'wernerkassens 2/27/2015 12:26'!
width
|max m|
max:=0.
self do: [:i|(m:= i width)isNaN ifTrue: [^m]. max :=max max: m].
^max! !

SortedCollection subclass: #IntervalUnion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Basic'!

!IntervalUnion commentStamp: 'WernerKassens 1/27/2016 16:42' prior: 0!
this is what its name says. it is implemented as a Collection of RealIntervals that can essentially be used like a RealInterval.  
!

!IntervalUnion class methodsFor: 'instance creation' stamp: 'wernerkassens 11/29/2014 18:03'!
from: anInteger to: anotherInteger 
|i|
(anInteger isInteger and:[anotherInteger isInteger ])
	ifFalse:[^self error:'only Integers allowed'].
i:=self new: anotherInteger -anInteger +1.
i addAll:( Interval from: anInteger  to: anotherInteger).
^i  
! !

!IntervalUnion class methodsFor: 'instance creation' stamp: 'wernerkassens 1/19/2015 14:18'!
new 
^self sortBlock: self sortBlock .! !

!IntervalUnion class methodsFor: 'instance creation' stamp: 'wernerkassens 1/19/2015 14:18'!
new:aSize 
|i|
i:=super new: aSize. 
i sortBlock: self sortBlock.
^i! !

!IntervalUnion class methodsFor: 'sorting' stamp: 'wernerkassens 1/19/2015 14:17'!
sortBlock
^[ :int1 :int2|
	int2 isEmpty or:
	[(int1 inf = int2 inf) 
		ifTrue:  [ int1 sup<int2 sup ] 
		ifFalse: [ int1 inf < int2 inf ] ]]! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:45'!
* anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f*s] ]
	ifFalse:  [ self intervalCollect: [ :i|i *anI ] ])! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:45'!
+ anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f+s] ]
	ifFalse:  [ self intervalCollect: [ :i|i +anI ] ])! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:45'!
- anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f-s] ]
	ifFalse:  [ self intervalCollect: [ :i|i -anI ] ])! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:45'!
/ anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f/s] ]
	ifFalse:  [ self intervalCollect: [ :i|i /anI ] ])! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:45'!
// anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f // s] ]
	ifFalse:  [ self intervalCollect: [ :i|i // anI ] ])! !

!IntervalUnion methodsFor: 'comparing' stamp: 'wernerkassens 1/15/2015 14:09'!
=anObject 
^anObject isIntervalUnion 
	ifTrue: [ self hasEqualElements: anObject ] 
	ifFalse: [ (self size=1) 
		ifTrue:[ anObject = self first ]
		ifFalse:[self isEmpty and:[anObject isRealInterval and:[anObject isEmpty]]]]
! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:45'!
\\ anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f \\ s] ]
	ifFalse:  [ self intervalCollect: [ :i|i \\ anI ] ])! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:42'!
abs
	^ self intervalCollect: [:a | a abs]! !

!IntervalUnion methodsFor: 'adapting' stamp: 'WernerKassens 2/9/2016 16:42'!
adaptToNumber: rcvr andSend: selector
"works also as adaptToRealInterval:andSend: , which does not exist"
selector = #= ifTrue:[^ self=rcvr ].
^self intervalCollect:[:i| rcvr perform: selector with: i]! !

!IntervalUnion methodsFor: 'adding' stamp: 'wernerkassens 1/19/2015 14:18'!
add: anInterval
anInterval isIntervalUnion
	ifTrue: [anInterval do: [:i| self add:i ]]
	ifFalse: [ anInterval isRealInterval 
			ifTrue: [ super add: anInterval ]
			ifFalse:[super add: (RealInterval fromNumber: anInterval) ]].
self reduce.
^anInterval  ! !

!IntervalUnion methodsFor: 'adding' stamp: 'wernerkassens 1/19/2015 14:19'!
addAll: aCol
aCol do:[:a|self add: a]. 
^aCol  ! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
arcCos 
	^ self intervalCollect: [:a | a arcCos ]! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
arcSin 
	^ self intervalCollect: [:a | a arcSin ]! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
arcTan 
	^ self intervalCollect: [:a | a arcTan ]! !

!IntervalUnion methodsFor: 'converting' stamp: 'wernerkassens 12/25/2014 17:12'!
asNumber
^(self size=1) 
	ifTrue: [ self first asNumber ] 
	ifFalse:[ self] ! !

!IntervalUnion methodsFor: 'truncation and round off' stamp: 'WernerKassens 2/9/2016 16:42'!
ceiling
	^ self intervalCollect: [:a | a ceiling]! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
cos
	^ self intervalCollect: [:a | a cos ]! !

!IntervalUnion methodsFor: 'accessing' stamp: 'WernerKassens 2/23/2016 15:59'!
cutPoint
^self size<2 
	ifTrue:[self size =1 
  		ifTrue: [self first cutPoint]
  		ifFalse:[Float nan]]
	ifFalse: [ (self inf<0 and:[self sup>0])
		ifTrue: [ 0.0 ] 
		ifFalse: [ self privateCutPoint ] ]! !

!IntervalUnion methodsFor: 'set operations' stamp: 'WernerKassens 2/9/2016 16:42'!
difference: anInt
|x|
^(anInt isIntervalUnion 
	ifTrue: [
		x:=self copy .
		anInt do:[:i|x:=x difference: i].
		x]
	ifFalse:  [ self intervalCollect: [ :i|i difference: anInt ] ])
! !

!IntervalUnion methodsFor: 'converting' stamp: 'WernerKassens 2/22/2016 18:58'!
enlargeToWidth: aNumber
"enlarges each interval in the union"
self do:[:i | i enlargeToWidth: aNumber].
self reduce.! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
exp
	^ self intervalCollect: [:a | a exp ]! !

!IntervalUnion methodsFor: 'truncation and round off' stamp: 'WernerKassens 2/9/2016 16:42'!
floor
	^ self intervalCollect: [:a | a floor]! !

!IntervalUnion methodsFor: 'truncation and round off' stamp: 'WernerKassens 2/9/2016 16:42'!
fractionPart
^ self intervalCollect: [:a | a fractionPart ]! !

!IntervalUnion methodsFor: 'comparing' stamp: 'wernerk 12/26/2014 11:24'!
hash
	| hash |
	self size=1 ifTrue:[^self first hash].
	self isEmpty ifTrue: [ ^RealInterval new hash ].
	hash := self species hash.
	self do: [:i | hash := (hash + i hash) hashMultiply].
	^hash! !

!IntervalUnion methodsFor: 'set operations' stamp: 'wernerkassens 12/6/2014 11:52'!
hull
self reduce.
self isEmpty ifTrue: [ ^RealInterval new ].
^RealInterval inf: self inf sup: self sup! !

!IntervalUnion methodsFor: 'set operations' stamp: 'wernerkassens 2/27/2015 17:01'!
hull: anInt
"this somewhat illogically accepts infinite numbers, which i found practically in some situations."
|r|
self isEmpty ifTrue: [ ^anInt isNumber ifTrue: [ RealInterval fromNumber: anInt  ] ifFalse:[anInt ]].
anInt isNumber ifTrue: 
	[^RealInterval inf:(anInt asNumber min: self inf) sup:(anInt asNumber max: self sup)].
r := self union: anInt.
r isEmpty ifTrue: [ ^RealInterval new ].
^RealInterval inf: r inf sup: r sup! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 1/15/2015 14:09'!
includes: aNumberOrInterval
aNumberOrInterval isIntervalUnion ifTrue: [ ^(self union: aNumberOrInterval) =self ].
^(aNumberOrInterval isRealInterval and:[aNumberOrInterval isEmpty]) 
	or:[self anySatisfy: [ :int|int includes: aNumberOrInterval ]]! !

!IntervalUnion methodsFor: 'accessing' stamp: 'wernerkassens 2/27/2015 14:48'!
inf
^self ifEmpty: [ Float nan ] ifNotEmpty: [self first inf]! !

!IntervalUnion methodsFor: 'accessing' stamp: 'wernerkassens 3/8/2015 08:57'!
inf: aNumber 
|i|
i:=self findFirst: [ :int|(aNumber < int inf) or:[int includes: aNumber ]].
i=0 
	ifTrue:[self removeAll ]
	ifFalse:[(i-1)timesRepeat: [ self removeFirst ]].
self isEmpty ifTrue: [ ^nil ].
self first inf:aNumber.
self reSort.
self reduce .
^aNumber 
 ! !

!IntervalUnion methodsFor: 'set operations' stamp: 'WernerKassens 2/9/2016 16:45'!
intersection: anInt
^(anInt isIntervalUnion 
	ifTrue: [ self with: anInt intervalCollect:[ :f :s|f intersection: s] ]
	ifFalse:  [ self intervalCollect: [ :i|i intersection: anInt ] ])
! !

!IntervalUnion methodsFor: 'enumerating' stamp: 'WernerKassens 2/9/2016 16:42'!
intervalCollect: aBlock 
"result of aBlock can be a Number, a RealInterval, or an IntervalCollection. the final result can reduce to a RealInterval. "
	| newCollection i| 
	newCollection := self class new: self size.
	self do: [:each | 
		i:=aBlock value: each .
		i isIntervalUnion 
			ifTrue: [ newCollection addAll: i ]
			ifFalse:[	(i isRealInterval) ifFalse:[i:=RealInterval fromNumber: i]. 	newCollection addLast: i]].
	^ newCollection reSort strongReduce ! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 1/11/2015 10:59'!
isAtomic
^self size=1 and:[self first isAtomic ]! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 12/23/2014 11:33'!
isFinite
^(self isEmpty or:[self isInfinite ])not! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 12/23/2014 11:31'!
isInfinite
^self isEmpty not and: [self first isInfinite or:[self last isInfinite ]]! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 1/15/2015 14:09'!
isIntervalUnion
^true! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 12/13/2014 12:23'!
isNumber 
^self size=1 and:[self first isNumber ]! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 11/25/2014 17:14'!
isZero
^false
"for divide by zero test in number/interval. nonsense but necessary in this form. you should use #isZeroInterval instead!!"! !

!IntervalUnion methodsFor: 'testing' stamp: 'wernerkassens 11/28/2014 10:10'!
isZeroInterval
^(self size=1)and: [ self first isZeroInterval  ]
! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
ln
	^ self intervalCollect: [:a | a ln]! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
log
	^ self intervalCollect: [:a | a log]! !

!IntervalUnion methodsFor: 'comparing' stamp: 'WernerKassens 2/9/2016 16:45'!
max:  anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f max: s] ]
	ifFalse:  [ self intervalCollect: [ :i|i max: anI ] ])! !

!IntervalUnion methodsFor: 'accessing' stamp: 'WernerKassens 2/24/2016 01:02'!
midPoint
"midpoint is always an element of self, while cut point usually isn't!!"
^self isFinite ifTrue: [ self privateMidPoint ] ifFalse: [self projectionFrom: self cutPoint ]! !

!IntervalUnion methodsFor: 'comparing' stamp: 'WernerKassens 2/9/2016 16:45'!
min:  anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f min: s] ]
	ifFalse:  [ self intervalCollect: [ :i|i min: anI ] ])! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:42'!
negated
	"Negated value of all elements in the collection"
	^ self intervalCollect: [:a | a negated] ! !

!IntervalUnion methodsFor: 'copying' stamp: 'wernerkassens 1/19/2015 14:19'!
postCopy
	super postCopy.
	array := array collect:[ :i|i copy].! !

!IntervalUnion methodsFor: 'printing' stamp: 'wernerkassens 3/19/2015 16:38'!
printElementsOn: aStream
	aStream nextPut: $(.
	self do: [:element | aStream print: element] separatedBy: [aStream nextPut: $u].
	aStream nextPut: $)! !

!IntervalUnion methodsFor: 'private' stamp: 'WernerKassens 2/24/2016 01:05'!
privateCutPoint
"only for IntervalUnions that consist of at least two RealIntervals"
|i|
i:= self size//2.
^(self at:i) sup + (self at:(i+1)) inf /2.0! !

!IntervalUnion methodsFor: 'private' stamp: 'wernerkassens 1/19/2015 17:09'!
privateMidPoint
^self projectionFrom:(self sup +self inf /2.0)! !

!IntervalUnion methodsFor: 'private' stamp: 'wernerkassens 3/20/2015 17:50'!
privateprojectionFrom: aNumber startingAt: anIndex directionUp: aBoolean
|col i result|
col:= aBoolean ifTrue: [ self ] ifFalse: [ self reverse ].
i:=aBoolean ifTrue: [ anIndex ] ifFalse: [ col size + 1 - anIndex ].
i to: col size do:[:j| result:=(col at:j) projectionFrom: aNumber. result isNaN ifFalse: [ ^result ]].
^result! !

!IntervalUnion methodsFor: 'accessing' stamp: 'wernerkassens 3/20/2015 23:36'!
projectionFrom: aNumber
"returns the nearest number in the receiver of the same type as aNumber, or Float nan if such a
number does not exist"
| y x|
(aNumber isNaN or:[self isEmpty ]) ifTrue: [ ^Float nan].
(aNumber < self inf) ifTrue: [ ^self privateprojectionFrom: aNumber startingAt: 1 directionUp: true].
(aNumber > self sup) ifTrue: [ ^self  privateprojectionFrom: aNumber startingAt: self size directionUp: false].
self findBinaryIndex: [ :interval | 
	x:=interval - aNumber. 
	(x inf >0) ifTrue: [-1] ifFalse: [ (x sup <0)	ifTrue: [1] ifFalse:[0] ] ]
  do: [ :found | ^aNumber]
  ifNone: [ :a :b | 
	x:=self  privateprojectionFrom: aNumber startingAt: a directionUp: false.
	y:=self  privateprojectionFrom: aNumber startingAt: b directionUp: true.
	x isNaN ifTrue: [ ^y ] ifFalse: [ y isNaN ifTrue: [ ^x ] ].
	^((x-aNumber)abs >(y-aNumber)abs)ifTrue: [ y ] ifFalse: [ x ] ] ! !

!IntervalUnion methodsFor: 'set operations' stamp: 'wernerkassens 3/27/2015 18:27'!
quasiUnion: anInt

^ self union: anInt! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:45'!
quo: anI
^(anI isIntervalUnion 
	ifTrue: [ self with: anI intervalCollect:[ :f :s|f quo: s] ]
	ifFalse:  [ self intervalCollect: [ :i|i quo: anI ] ])! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:45'!
raisedTo: anInt
^(anInt isIntervalUnion 
	ifTrue: [ self with: anInt intervalCollect:[ :f :s|f raisedTo: s] ]
	ifFalse:  [ self intervalCollect: [ :i|i raisedTo: anInt ] ])! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:45'!
raisedToInteger: anInteger
^(anInteger isIntervalUnion 
	ifTrue: [ self with: anInteger intervalCollect:[ :f :s|f raisedToInteger: s] ]
	ifFalse:  [ self intervalCollect: [ :i|i raisedToInteger: anInteger ] ])! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/9/2016 16:42'!
reciprocal
	^ self intervalCollect: [:a | a reciprocal]! !

!IntervalUnion methodsFor: 'converting' stamp: 'wernerkassens 12/26/2014 15:41'!
reduce
|i j|
i:=1.
[[(i<=self size)and: [(self at:i)isEmpty]] whileTrue: 
	[ self removeAt: i . 
	  (i>1)ifTrue:[i:=i-1] ].
 (j:=i+1) <= self size] whileTrue:
	[ (self at:j)inf <= (self at:i)sup 
		ifTrue: [ "this complicated form _is necessary, one _has to make a new interval:"
				array at: i + firstIndex - 1 put: (RealInterval inf: (self at:i)inf sup:((self at:i)sup max: (self at:j)sup)).
				self removeAt: j ] 
		ifFalse: [ i:=i+1 ]  ].


! !

!IntervalUnion methodsFor: 'truncation and round off' stamp: 'WernerKassens 2/9/2016 16:42'!
rounded
	^ self intervalCollect: [:a | a rounded ]! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
sign
^(self intervalCollect: [:a | a sign ]) asNumber! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
simpleSign
self size =1 ifTrue:[^self first simpleSign ].
^(self intervalCollect: [:a | a isZeroInterval ifTrue: [RealInterval new] ifFalse: [a simpleSign] ]) asNumber! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
sin
	^ self intervalCollect: [:a | a sin ]! !

!IntervalUnion methodsFor: 'private' stamp: 'wernerkassens 1/15/2015 13:55'!
species
^IntervalUnion ! !

!IntervalUnion methodsFor: 'converting' stamp: 'wernerkassens 1/17/2015 12:33'!
split
^self split: self cutPoint .
! !

!IntervalUnion methodsFor: 'converting' stamp: 'wernerkassens 1/15/2015 13:55'!
split:at
|n p|
n:=IntervalUnion new.
p:=IntervalUnion new.
self do:[:ri||s|
	s:=ri split:at.
	s ifNil: [(at<=ri inf)ifTrue: [ p addLast: ri ] ifFalse: [ n addLast: ri ]  ]
	  ifNotNil: [ n addLast:s first. p addLast: s second]].
p reSort strongReduce.
n reSort strongReduce.
^Array with: n with: p

! !

!IntervalUnion methodsFor: 'converting' stamp: 'wernerkassens 1/17/2015 12:21'!
splitAtZero
|n p|
n:=IntervalUnion new.
p:=IntervalUnion new.
self do:[:ri||s|s:=ri splitAtZero. n addLast:s first. p addLast: s second].
p reSort strongReduce.
n reSort strongReduce.
^Array with: n with: p

! !

!IntervalUnion methodsFor: 'converting' stamp: 'WernerKassens 2/23/2016 16:19'!
splitTimes: anInteger 
"in a way nonsense, but then who cares, its simple for a simple algo-example"
|c|
c:=OpenIntervalUnion newFrom: self.
^c intervalCollect: [ :i|i splitTimes: anInteger  ].! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
sqrt
	^ self intervalCollect: [:a | a sqrt ]! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
squared 
	^ self intervalCollect: [:a | a squared  ]! !

!IntervalUnion methodsFor: 'converting' stamp: 'wernerkassens 1/21/2015 22:58'!
strongReduce
|x|
"at the moment in IntervalUnion only used by split, split:, icollect: and with:icollect:. also used in SkelboeMoore algo. can be a bit tricky"
self reduce.
self isEmpty 
	ifTrue: [ x:=RealInterval new . self become: x ] 
	ifFalse:[self size =1 ifTrue:[x:=self first copy. self become: x]].
! !

!IntervalUnion methodsFor: 'arithmetic' stamp: 'WernerKassens 2/17/2016 08:41'!
sum
"it can be irritating if this works, hence:"
^self shouldNotImplement ! !

!IntervalUnion methodsFor: 'accessing' stamp: 'wernerkassens 2/27/2015 14:49'!
sup
^self ifEmpty: [ Float nan ] ifNotEmpty: [self last sup] ! !

!IntervalUnion methodsFor: 'accessing' stamp: 'wernerkassens 12/13/2014 17:07'!
sup:aNumber 
|i|
i:=self findLast: [ :int|(aNumber > int sup) or:[int includes: aNumber ]].
(self size - i )timesRepeat: [ self removeLast ].
self isEmpty ifTrue: [ ^nil ].
self last sup:aNumber .
self reSort.
self reduce .
^aNumber ! !

!IntervalUnion methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/9/2016 16:42'!
tan
	^ self intervalCollect: [:a | a tan ]! !

!IntervalUnion methodsFor: 'truncation and round off' stamp: 'WernerKassens 2/9/2016 16:42'!
truncated
	^ self intervalCollect: [:a | a truncated ]! !

!IntervalUnion methodsFor: 'set operations' stamp: 'wernerkassens 1/15/2015 14:09'!
union: anInt
^(anInt isIntervalUnion 
	ifTrue: [ self copy addAll: anInt; yourself  ]
	ifFalse:  [ self copy add: anInt; yourself  ])
! !

!IntervalUnion methodsFor: 'accessing' stamp: 'wernerkassens 12/22/2014 19:51'!
width
|x|
self isEmpty ifTrue: [ ^Float nan ].
x:=0.
self do: [ :i|x:=x + i width ].
^x! !

!IntervalUnion methodsFor: 'enumerating' stamp: 'WernerKassens 2/9/2016 16:45'!
with: anICollection intervalCollect: aBlock 
"combine everything in receiver with everything in anICollection. not comparable with #with:collect: . 
 necessary for binary methods like #+, #- etc. 
result of aBlock can be a RealInterval or an IntervalCollection; not a Number (!!), as i think at the moment its not really necessary.
final result can reduce to a RealInterval ."
	| newCollection i| 
	newCollection := self class new: (self size * anICollection size).
	self do: [:each |anICollection do: [:x|
			i:=aBlock value: each value: x.
			i isIntervalUnion 
				ifTrue: [ newCollection addAll: i ]
				ifFalse: [ newCollection addLast: i]]].
	^newCollection reSort strongReduce.
! !

IntervalUnion subclass: #OpenIntervalUnion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Basic'!

!OpenIntervalUnion commentStamp: 'WernerKassens 2/2/2016 18:24' prior: 0!
An OpenIntervalUnion is an IntervalUnion that does not reduce intervals with adjacent bounderies . (experimental)!

!OpenIntervalUnion methodsFor: 'converting' stamp: 'wernerkassens 11/29/2014 17:15'!
reduce
|i j|
i:=1.
[[(i<=self size)and: [(self at:i)isEmpty]] whileTrue: 
	[ self removeAt: i . 
	  (i>1)ifTrue:[i:=i-1] ].
 (j:=i+1) <= self size] whileTrue:
	[ (self at:j)inf < (self at:i)sup 
		ifTrue: [array at: i + firstIndex - 1 put: (RealInterval inf: (self at:i)inf sup:((self at:i)sup max: (self at:j)sup)).
				self removeAt: j ] 
		ifFalse: [ (self at:i)=(self at:j)
			ifTrue: [ self removeAt: j ] 
			ifFalse: [ i:=i+1 ]  ]]

! !

DhbIterativeProcess subclass: #BoxSplicing
	instanceVariableNames: 'constraints left epsilon dimension'
	classVariableNames: 'FastMaxIterations'
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!BoxSplicing commentStamp: 'wernerkassens 3/2/2015 18:08' prior: 0!
BoxSplicing implements the boxsplicing algo. you have to set the constraints and the initial box.  the algo is run with doSplicing (1x), doFastSplicing (3x by default) or doRepeatedSplicing (as often as necessary) .!

!BoxSplicing class methodsFor: 'instance creation' stamp: 'wernerkassens 1/28/2015 15:25'!
constraints: aCollectionOfConstraints

	^ self new
		constraints: aCollectionOfConstraints;
		yourself! !

!BoxSplicing class methodsFor: 'instance creation' stamp: 'wernerkassens 2/3/2015 17:56'!
constraints: aCollectionOfConstraints box: initialBox
	^ (self constraints: aCollectionOfConstraints) box:initialBox;
		yourself! !

!BoxSplicing class methodsFor: 'acccessing' stamp: 'wernerkassens 3/2/2015 15:39'!
fastMaxIterations
^FastMaxIterations ! !

!BoxSplicing class methodsFor: 'acccessing' stamp: 'wernerkassens 3/2/2015 15:57'!
fastMaxIterations: anInteger
self assert: (anInteger isInteger and:[anInteger >0]).
^FastMaxIterations:=anInteger ! !

!BoxSplicing class methodsFor: 'class initialization' stamp: 'wernerkassens 3/2/2015 15:42'!
initialize 
FastMaxIterations :=3.! !

BoxSplicing initialize!

!BoxSplicing methodsFor: 'accessing' stamp: 'wernerkassens 1/3/2015 09:57'!
addConstraint: aConstraint
^constraints add:aConstraint ! !

!BoxSplicing methodsFor: 'accessing' stamp: 'wernerkassens 2/10/2015 16:25'!
box: aSequentialCollection
^aSequentialCollection isSequenceable 
	ifTrue: [ result := aSequentialCollection copy ] 
	ifFalse: [ self error ]
! !

!BoxSplicing methodsFor: 'accessing' stamp: 'wernerkassens 1/3/2015 09:55'!
constraints
^constraints  ! !

!BoxSplicing methodsFor: 'accessing' stamp: 'WernerKassens 3/6/2016 13:04'!
constraints: aCollectionOfConstraints
^constraints:= ConstraintsCollection newFrom: aCollectionOfConstraints ! !

!BoxSplicing methodsFor: 'operation' stamp: 'wernerkassens 3/2/2015 17:24'!
doFastSplicing
|old i|
i:=0.
result ifNil:[self error:'Box is not initialized'].
[old:=result copy. self doSplicing.i:=i+1.i=FastMaxIterations or:[old = result]]whileFalse . 
^result! !

!BoxSplicing methodsFor: 'operation' stamp: 'wernerkassens 3/31/2015 11:43'!
doRepeatedSplicing
|old|
result ifNil:[self error:'Box is not initialized'].
[old:=result copy. self doSplicing. old = result]whileFalse. 
^result! !

!BoxSplicing methodsFor: 'operation' stamp: 'WernerKassens 3/6/2016 13:06'!
doSplicing
(constraints  isNotAdmissibleValue:result) 
	ifTrue: [ 1 to: result size do:[:i|result at:i put:RealInterval new].^result].
left:=true.
1 to: result size do:[:i|dimension :=i. self evaluate.].
left:=false.
1 to: result size do:[:i|dimension :=i. self evaluate.].
^result! !

!BoxSplicing methodsFor: 'operation' stamp: 'WernerKassens 3/6/2016 13:07'!
evaluateIteration
|aBox int|
epsilon := epsilon / 2.0.
aBox:=result collect: [:i|i copy].
int:=(aBox at: dimension).
left ifTrue: [ int sup: (epsilon+int inf) ] 
	ifFalse: [int inf: (int sup - epsilon)] .
^(constraints isNotAdmissibleValue: aBox) 
	ifTrue: [ result at: dimension put:((result at: dimension)  difference: int). 0 ] 
	ifFalse: [ 1 ]
! !

!BoxSplicing methodsFor: 'initialization' stamp: 'WernerKassens 3/6/2016 13:04'!
initialize

	super initialize.
	constraints := ConstraintsCollection new.
	self maximumIterations: 52. "use complete precision of floats"
! !

!BoxSplicing methodsFor: 'operation' stamp: 'wernerkassens 1/28/2015 15:34'!
initializeIterations
epsilon :=(result at: dimension)width .
! !

!BoxSplicing methodsFor: 'printing' stamp: 'wernerkassens 1/28/2015 16:19'!
printOn: aStream
	super printOn: aStream .
	aStream nextPutAll: '(box: ' .
	result printOn: aStream .
	aStream nextPutAll: ' constraints: ' .
	constraints printOn: aStream.
	aStream nextPut: $).! !

DhbIterativeProcess subclass: #ConstraintRefinement
	instanceVariableNames: 'constraints box initialQueue myDesiredPrec fast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!ConstraintRefinement commentStamp: 'wernerkassens 2/8/2015 09:51' prior: 0!
A ConstraintRefinement calcs the refinement of a box so that all constraints are fullfilled.!

!ConstraintRefinement class methodsFor: 'instance creation' stamp: 'wernerkassens 2/3/2015 23:45'!
constraints: aCollectionOfConstraints

	^ self new
		constraints: aCollectionOfConstraints;
		yourself! !

!ConstraintRefinement class methodsFor: 'instance creation' stamp: 'wernerkassens 2/3/2015 23:45'!
constraints: aCollectionOfConstraints box: initialBox
	^ (self constraints: aCollectionOfConstraints) box:initialBox;
		yourself! !

!ConstraintRefinement class methodsFor: 'information' stamp: 'wernerkassens 2/4/2015 17:30'!
defaultMaximumIterations
	^1000! !

!ConstraintRefinement class methodsFor: 'information' stamp: 'wernerkassens 2/3/2015 21:55'!
defaultPrecision
	^5e-5! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 2/3/2015 23:43'!
addConstraint: aConstraint
^constraints add:aConstraint ! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 2/7/2015 18:56'!
box: anObject
box :=anObject copy.
^result := anObject copy! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 2/3/2015 23:44'!
constraints
^constraints  ! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'WernerKassens 3/3/2016 08:24'!
constraints: aCollectionOfConstraints
^constraints:= ConstraintsCollection newFrom:aCollectionOfConstraints! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 2/3/2015 21:55'!
desiredPrecision
"true if the desiredPrecision is reached. 
false if calculation has stopped because maximumIterations are used"
^precision =0! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 2/3/2015 21:55'!
desiredPrecision: aNumber
aNumber > 0
		ifFalse: [ ^self error: 'precision too low'].
^ myDesiredPrec :=aNumber! !

!ConstraintRefinement methodsFor: 'operation' stamp: 'WernerKassens 2/22/2016 14:23'!
evaluateIteration
	| aSplit adm|
	[aSplit := initialQueue removeFirst]on: Error do:[^0] .	"iterations =29 ifTrue:[self halt]."	"3."
	(constraints isNotAdmissibleValue: aSplit)	ifTrue: [ ^ self returnPrecision ]."4."
	aSplit := aSplit split."5"
	aSplit do: [:aBox| adm:=constraints admissibleNumberForValue: aBox.
		aBox width < myDesiredPrec	"6"	
			ifTrue: [ adm > 0 ifTrue: [self resultAdd: aBox ]]"7"
			ifFalse: [ adm > 0 ifTrue: 
				[adm  =2 
					ifTrue:[self resultAdd: aBox] 
					ifFalse: [initialQueue addFirst: aBox] ] ]]."9"
	^ self returnPrecision
! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 3/2/2015 17:55'!
fast
^fast! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 3/2/2015 16:51'!
fast: aBoolean 
^fast := aBoolean ! !

!ConstraintRefinement methodsFor: 'operation' stamp: 'wernerkassens 3/17/2015 14:38'!
finalizeIterations
myDesiredPrec :=0.
initialQueue ifNotEmpty: [ myDesiredPrec := initialQueue size. result addAll:initialQueue ].
initialQueue :=nil.
! !

!ConstraintRefinement methodsFor: 'initialization' stamp: 'wernerkassens 3/2/2015 16:50'!
initialize
super initialize .
	myDesiredPrec := self class defaultPrecision.
	desiredPrecision := 0.
	constraints := ConstraintsCollection new.
	fast := false.
! !

!ConstraintRefinement methodsFor: 'operation' stamp: 'wernerkassens 3/20/2015 16:31'!
initializeIterations
|aBox|
result := OrderedCollection new.
initialQueue := "LinkedList new"OrderedCollection new:50. "LinkedList seems to be a bit slower"
(aBox :=(BoxSplicing constraints: constraints  box: box )doFastSplicing)isEmpty 
	ifTrue:[^result add:aBox] .
initialQueue add: aBox.
! !

!ConstraintRefinement methodsFor: 'printing' stamp: 'wernerkassens 2/10/2015 15:08'!
printOn: aStream
	super printOn: aStream .
	aStream nextPutAll: '(box: ' .
	box printOn: aStream .
	aStream nextPutAll: ' constraints: ' .
	constraints printOn: aStream.
	aStream nextPut: $).! !

!ConstraintRefinement methodsFor: 'private' stamp: 'wernerkassens 3/17/2015 14:31'!
resultAdd: aBox
|b col|
col:=aBox asSimpleBoxes .
col do:[:abox|
	b :=BoxSplicing constraints: constraints  box: abox.
	b:= fast ifTrue: [ b doFastSplicing ] ifFalse: 
		[b doRepeatedSplicing ] .
	b ifNotEmpty: [ result add: b ]].! !

!ConstraintRefinement methodsFor: 'private' stamp: 'wernerkassens 2/4/2015 01:28'!
returnPrecision
^(initialQueue isEmpty )ifTrue: [ 0 ] ifFalse:[1]! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'WernerKassens 3/9/2016 19:53'!
sloppyResult
^result reduce: [:aBox :bBox| aBox quasiUnion: bBox ].! !

!ConstraintRefinement methodsFor: 'accessing' stamp: 'wernerkassens 2/26/2015 09:59'!
unpreciseResults
"after finalizeIterations is called, this returns the number of those results that have not reached the desired precision. those results are the last in result"
^ myDesiredPrec! !

DhbIterativeProcess subclass: #SkelboeMoore1
	instanceVariableNames: 'box function min severalBoxes useSloppySimplification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!SkelboeMoore1 commentStamp: 'wernerkassens 1/18/2015 13:12' prior: 0!
A SkelboeMoore1  algo is run with #evaluate and returns an array of the domain and the range of the minimum of a function . you have to set the function and the box!

SkelboeMoore1 subclass: #ConstraintsMinimizer1
	instanceVariableNames: 'constraints splicer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!ConstraintsMinimizer1 commentStamp: 'WernerKassens 3/9/2016 11:04' prior: 0!
ConstraintsMinimizer1  is a SkelboeMoore1 algo where you can add  Constraints.!

!ConstraintsMinimizer1 class methodsFor: 'information' stamp: 'WernerKassens 2/24/2016 00:20'!
defaultMaximumIterations
	^3000! !

!ConstraintsMinimizer1 class methodsFor: 'instance creation' stamp: 'WernerKassens 2/21/2016 17:28'!
function: aBlock box: anIntervalBoxOrRealIntervalOrIntervalUnion constraints: aCollectionOfConstraints
^self new 
	function: aBlock ;
	box: anIntervalBoxOrRealIntervalOrIntervalUnion;
	constraints: aCollectionOfConstraints;
	yourself  ! !

!ConstraintsMinimizer1 methodsFor: 'accessing' stamp: 'WernerKassens 2/21/2016 17:26'!
addConstraint: aConstraint
^constraints add:aConstraint ! !

!ConstraintsMinimizer1 methodsFor: 'operation' stamp: 'WernerKassens 2/21/2016 18:02'!
cleanUp
|r|
result ifEmpty: [ r:= RealInterval new.result:={Array with: r with: r} ].
^super cleanUp .! !

!ConstraintsMinimizer1 methodsFor: 'accessing' stamp: 'WernerKassens 2/21/2016 17:26'!
constraints
^constraints ! !

!ConstraintsMinimizer1 methodsFor: 'accessing' stamp: 'WernerKassens 3/3/2016 08:22'!
constraints: aCollectionOfConstraints
^constraints:= ConstraintsCollection newFrom:aCollectionOfConstraints! !

!ConstraintsMinimizer1 methodsFor: 'operation' stamp: 'WernerKassens 3/9/2016 10:56'!
evaluateIteration
|aBox|
aBox :=result removeFirst . "iterations =47 ifTrue:[self halt]."
aBox second inf > min 
	ifFalse: [(aBox first split) 
	  ifNil: [result addLast: aBox] 
	  ifNotNil: [ :aSplit| |domain codomain mp|
		1 to:2 do:[:index|
			domain := splicer box:(aSplit at: index);doFastSplicing. "lazy stupid trick, 
											but in a way necessary for the next stupidity"
			codomain := function value: domain.
			(codomain inf <= min and:[constraints isPerhapsAdmissibleValue: domain])
				ifTrue:[ 
					result addLast: (Array with: domain with: codomain).
					min := min min:	codomain sup. "this is not (!!) correct, but works relatively 
															often with the stupidity above"
					(constraints isAdmissibleValue: (mp:=domain midPoint)) 
						ifTrue:[min := min min: (function value:mp)]]]
		]].
^result isEmpty ifTrue:[0] ifFalse:[result first first width]! !

!ConstraintsMinimizer1 methodsFor: 'initialization' stamp: 'WernerKassens 3/9/2016 03:01'!
initialize
super initialize .
constraints := ConstraintsCollection new.! !

!ConstraintsMinimizer1 methodsFor: 'operation' stamp: 'WernerKassens 3/16/2016 14:27'!
initializeIterations
constraints enlargeToWidth: desiredPrecision *2 .
splicer:=BoxSplicing constraints: constraints.
super initializeIterations .
min := (function value: box)sup.
! !

!SkelboeMoore1 class methodsFor: 'information' stamp: 'wernerkassens 1/17/2015 16:08'!
defaultMaximumIterations
	^1300! !

!SkelboeMoore1 class methodsFor: 'information' stamp: 'wernerkassens 1/18/2015 13:30'!
defaultPrecision
	^10e-20! !

!SkelboeMoore1 class methodsFor: 'instance creation' stamp: 'wernerkassens 1/19/2015 16:58'!
function: aBlock box: anIntervalBoxOrRealIntervalOrIntervalUnion
^self new function: aBlock ;box: anIntervalBoxOrRealIntervalOrIntervalUnion;yourself  ! !

!SkelboeMoore1 class methodsFor: 'instance creation' stamp: 'wernerkassens 3/31/2015 14:28'!
function: aBlock boxes: anArrayOfIntervalBoxes
^self new function: aBlock ;boxes: anArrayOfIntervalBoxes;yourself  ! !

!SkelboeMoore1 methodsFor: 'accessing' stamp: 'wernerkassens 3/31/2015 14:13'!
box: anIntervalBoxOrRealIntervalOrIntervalUnion
severalBoxes :=false.
^box := anIntervalBoxOrRealIntervalOrIntervalUnion! !

!SkelboeMoore1 methodsFor: 'accessing' stamp: 'wernerkassens 3/31/2015 14:14'!
boxes: anArrayOfIntervalBoxes
severalBoxes :=true.
^box := anArrayOfIntervalBoxes! !

!SkelboeMoore1 methodsFor: 'operation' stamp: 'WernerKassens 3/8/2016 20:10'!
cleanUp
|domain range isNoBox|
domain :=(isNoBox :=(severalBoxes ifTrue: [ box first ] ifFalse: [box]) isRealInterval) 
	ifTrue: [IntervalUnion new]
	ifFalse:[OrderedCollection new].
range :=IntervalUnion new.
result do: [ :i|domain add:i first.range add: i last ].
domain ifNotEmpty: [isNoBox 
	ifTrue:[ domain strongReduce] 
	ifFalse: [self useSloppySimplification ifTrue: [domain := domain reduce: [:aBox :bBox| aBox quasiUnion: bBox ]] ]].
range strongReduce.
^result:=Array with: domain with: range  ! !

!SkelboeMoore1 methodsFor: 'operation' stamp: 'WernerKassens 2/13/2016 15:10'!
evaluateIteration
|aBox aResult|
aBox :=result removeFirst . "iterations =128 ifTrue:[self halt]."
aBox second inf > min 
	ifFalse: [(aBox first split) 
	  ifNil: [result addLast: aBox] 
	  ifNotNil: [ :aSplit| 
		aResult :=aSplit collect: [ :i|function value:i ].
		1 to:2 do:[:index||res|res:=aResult at: index.
			res inf <= min ifTrue:[ 
				result addLast: (Array with: (aSplit at: index) with: res).
				min := {
					min.
					(function value: (aSplit at: index)midPoint)asFloat successor.
					res sup} min ]]]].
^result first first width! !

!SkelboeMoore1 methodsFor: 'operation' stamp: 'wernerkassens 4/2/2015 16:03'!
finalizeIterations
^self cleanUp ! !

!SkelboeMoore1 methodsFor: 'accessing' stamp: 'wernerkassens 1/17/2015 11:30'!
function: aBlock
^function := aBlock! !

!SkelboeMoore1 methodsFor: 'operation' stamp: 'wernerkassens 3/31/2015 14:19'!
initializeIterations
|aBox|
result := LinkedList new.
severalBoxes 
	ifTrue: [box do:[:b| result addLast: (Array with: b with: (function value: b))].
		aBox:=box first ]
	ifFalse: [result addLast: (Array with: box with: (function value: box)). aBox:=box].
min :=function value: aBox midPoint.! !

!SkelboeMoore1 methodsFor: 'accessing' stamp: 'WernerKassens 2/11/2016 15:54'!
useSloppySimplification
^ useSloppySimplification ifNil: [ useSloppySimplification:=true ]! !

!SkelboeMoore1 methodsFor: 'accessing' stamp: 'WernerKassens 2/11/2016 15:55'!
useSloppySimplification:aBoolean
"is by default true and can result in a domain to wide for the range, but if it is set to false, the unsimplified domain can become _very_ difficult to read. has the same effect for SkelboeMoore2"
^ useSloppySimplification:=aBoolean! !

SkelboeMoore1 subclass: #SkelboeMoore2
	instanceVariableNames: 'initialQueue myDesiredPrec inexactResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!SkelboeMoore2 commentStamp: 'WernerKassens 3/9/2016 11:11' prior: 0!
SkelboeMoore2 should be faster than SkelboeMoore1 - ehhm, i think - but the speed gain is questionable. and SkelboeMoore1 gives almost always a sensible result, whereas SkelboeMoore2 needs to have a sufficiently high maximumIterations number for that.
perhaps some thinking is necessary here.!

!SkelboeMoore2 class methodsFor: 'information' stamp: 'WernerKassens 2/23/2016 19:12'!
defaultMaximumIterations
	^5000! !

!SkelboeMoore2 class methodsFor: 'information' stamp: 'wernerkassens 3/19/2015 17:50'!
defaultPrecision
	^2e-5! !

!SkelboeMoore2 methodsFor: 'accessing' stamp: 'wernerkassens 1/22/2015 00:55'!
desiredPrecision
"true if the desiredPrecision is reached. 
false if calculation has stopped because maximumIterations are used"
^precision =0! !

!SkelboeMoore2 methodsFor: 'accessing' stamp: 'wernerkassens 1/22/2015 00:48'!
desiredPrecision: aNumber
aNumber > 0
		ifFalse: [ ^self error: 'precision too low'].
^ myDesiredPrec :=aNumber! !

!SkelboeMoore2 methodsFor: 'operation' stamp: 'WernerKassens 2/13/2016 17:21'!
evaluateIteration
	| aSplit |
	aSplit := initialQueue removeFirst.	"iterations =10 ifTrue:[self halt]."	"3."
	aSplit second inf > min	ifTrue: [ ^ self returnPrecision ]."4."
	aSplit := aSplit first split collect: [ :i ||f|
		f :=function value: i.
		f isEmpty ifFalse: [ 
		min := ( min min:(function value: i midPoint) asFloat successor) min: f sup].
		Array with: i with: f ]."5"
	aSplit do: [: domCo||co| "+further tests"
		((co:=domCo second) width < myDesiredPrec)"6"	
			ifTrue: [ co inf <= min ifTrue: [self resultAdd: domCo ]]"7"
			ifFalse: [ initialQueue add: domCo ]]."9"
	^ self returnPrecision! !

!SkelboeMoore2 methodsFor: 'operation' stamp: 'wernerkassens 4/2/2015 16:03'!
finalizeIterations
|domCo|"do not use ifEmpty:etc here"
inexactResults := 0.
[initialQueue isEmpty ifTrue:[true]ifFalse:
	[(domCo :=initialQueue removeFirst) second inf <=min 
		ifTrue:[result add:domCo. inexactResults :=inexactResults +1. false]
		ifFalse:[true]]] whileFalse.
initialQueue :=nil.
^self cleanUp ! !

!SkelboeMoore2 methodsFor: 'accessing' stamp: 'wernerkassens 3/23/2015 18:50'!
inExactResults
"the number of inexact results at the end"
^inexactResults ! !

!SkelboeMoore2 methodsFor: 'initialization' stamp: 'wernerkassens 2/27/2015 13:16'!
initialize
	super initialize .
	myDesiredPrec := self class defaultPrecision.
	desiredPrecision := 0.
	^self! !

!SkelboeMoore2 methodsFor: 'operation' stamp: 'wernerkassens 3/31/2015 14:24'!
initializeIterations
|aBox|
result := IntervalHeap newQueue.
initialQueue := "SortedIntervalCollection new "IntervalHeap newQueue.
severalBoxes 
	ifTrue: [box do:[:b| initialQueue add: (Array with: b with: (function value: b))].
		aBox:=box first ]
	ifFalse: [initialQueue add: (Array with: box with: (function value: box)). aBox:=box].
min :=function value: aBox midPoint.! !

!SkelboeMoore2 methodsFor: 'private' stamp: 'wernerkassens 3/19/2015 17:20'!
resultAdd: aHalfSplit
(result isEmpty not and: [ result first second inf > min ])
	ifTrue: [ result := IntervalHeap newQueue].
result add: aHalfSplit 	! !

!SkelboeMoore2 methodsFor: 'private' stamp: 'wernerkassens 2/1/2015 11:46'!
returnPrecision
^(initialQueue isEmpty or:[initialQueue first second inf>min])ifTrue: [ 0 ] ifFalse:[1]! !

RTAxisAdaptedBuilder subclass: #ShapesWithAxisBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-utils'!

!ShapesWithAxisBuilder commentStamp: 'wernerkassens 3/7/2015 15:36' prior: 0!
A ShapesWithAxisBuilder produces a view of the shapes of elements like eg rectangles with a x-axis, and a y-axis turned upside down
!

!ShapesWithAxisBuilder methodsFor: 'accessing' stamp: 'wernerkassens 3/4/2015 18:00'!
axisOrigin
	^ (minX - self margin)@(maxY + self margin)! !

!ShapesWithAxisBuilder methodsFor: 'initialization' stamp: 'wernerkassens 3/6/2015 23:26'!
initialize
	super initialize.
	xAxisConfiguration tickLabelOffset: 0 @ 20.! !

!ShapesWithAxisBuilder methodsFor: 'accessing' stamp: 'wernerkassens 3/14/2015 10:01'!
yAxisDefaultConfigurationOrigin: aPoint toPoint: anotherPoint
	yAxisConfiguration 
		fromPoint: aPoint;
		toPoint: anotherPoint;
		maxValue: anotherPoint y negated ;
	 	minValue: aPoint y negated.
! !

!ShapesWithAxisBuilder methodsFor: 'accessing' stamp: 'wernerkassens 3/4/2015 17:58'!
yAxisPoint: aFixedX
	^ aFixedX@(minY - self margin)! !

OrderedCollection subclass: #ConstraintsCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-utils'!

!ConstraintsCollection commentStamp: 'WernerKassens 2/22/2016 09:12' prior: 0!
A ConstraintsCollection can test a value for all constraints in itself.
!

!ConstraintsCollection class methodsFor: 'instance creation' stamp: 'wernerkassens 9/15/2017 15:53'!
newFrom: aCollectionOfConstraintsOrConstraint
	^ aCollectionOfConstraintsOrConstraint isCollection 
		ifTrue: [ super newFrom: aCollectionOfConstraintsOrConstraint ] 
		ifFalse: [ self with: aCollectionOfConstraintsOrConstraint ]
! !

!ConstraintsCollection methodsFor: 'accessing' stamp: 'WernerKassens 3/8/2016 19:14'!
admissibleNumberForValue: aValue
"returns 0 if aValue is not admissible, 1 if it is partly admissible or undecidable and 2 if it is completely admissible"
|a i|
a:=0.
self do:[:c| 
	i:=(c admissibleNumberForValue: aValue).
	i=0 ifTrue:[^0]ifFalse:[i=2 ifTrue:[a:=a+1]]]. 
self size = a ifTrue: [ ^2 ].
^1
! !

!ConstraintsCollection methodsFor: 'converting' stamp: 'WernerKassens 3/9/2016 02:18'!
enlargeToWidth: aNumber
self do:[:c|c enlargeToWidth: aNumber].! !

!ConstraintsCollection methodsFor: 'testing' stamp: 'WernerKassens 3/8/2016 19:06'!
isAdmissibleValue: aValue
^self allSatisfy: [ :c| c isAdmissibleValue: aValue ]! !

!ConstraintsCollection methodsFor: 'testing' stamp: 'WernerKassens 2/22/2016 09:34'!
isNotAdmissibleValue: aValue
^self anySatisfy: [ :c| c isNotAdmissibleValue: aValue ]! !

!ConstraintsCollection methodsFor: 'testing' stamp: 'WernerKassens 3/9/2016 02:54'!
isPerhapsAdmissibleValue: aValue
^(self isNotAdmissibleValue: aValue)not
! !

Object subclass: #BoxVisualizer
	instanceVariableNames: 'aView dimensions result usedResult zoomFactor decimals color withBorder backgroundColor window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!BoxVisualizer commentStamp: 'WernerKassens 2/2/2016 18:07' prior: 0!
A BoxVisualizer  lets you visualize the result of ConstraintRefinement or generally a Collection of Boxes. use it like this:
(Visualizer result: aCollectionOfBoxes)show.!

!BoxVisualizer class methodsFor: 'instance creation' stamp: 'wernerkassens 2/26/2015 17:49'!
result: aCollectionOfBoxes
^self new result:aCollectionOfBoxes;yourself ! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'wernerkassens 3/27/2015 14:02'!
backgroundColor: aColor 
self checkResult.
backgroundColor :=aColor.
aView canvas color:aColor.
^backgroundColor! !

!BoxVisualizer methodsFor: 'private' stamp: 'wernerkassens 3/27/2015 12:30'!
boxesIntoView
|box|
box:=RTBox new 
		borderColor:(withBorder 
			ifTrue: [Color darkGray]
			ifFalse:[color]) ;
		color: color.
self calcUsedResult .
usedResult do: [ :r | |x|
	x:= box elementOn: r . 
	x trachelShape 
		from: (r first inf @ r second inf negated) * zoomFactor 
		to: (r first sup @ r second sup negated) * zoomFactor . 
	aView add:x].
aView elements do: [ :e | e @ (RTPopup text: [:el | el ])].
! !

!BoxVisualizer methodsFor: 'private' stamp: 'wernerkassens 3/27/2015 18:40'!
calcBuilder
|aBuilder|
self checkResult.
aBuilder := ShapesWithAxisBuilder new.
self calcView .
aBuilder view: aView.
aBuilder objects: aView elements . 
aBuilder margin: 6.
aBuilder yAxisConfiguration labelConversion:
	[:i|(i/zoomFactor) asFloat round: decimals ];title:('dim:',dimensions second asString).
aBuilder xAxisConfiguration labelConversion:
	[:i|(i/zoomFactor) asFloat round: decimals];titlePosition: -35@0; title:('dim:',dimensions first asString).
^aBuilder build.! !

!BoxVisualizer methodsFor: 'private' stamp: 'wernerkassens 2/26/2015 18:30'!
calcUsedResult
usedResult := (result first size=2 and:[dimensions =#(1 2)])
	ifTrue:[result]
	ifFalse:[result collect: [ :box|
		IntervalBox with: (box at:(dimensions first)) with: (box at:(dimensions second))]].
self calcZoomFactor .
^usedResult 
! !

!BoxVisualizer methodsFor: 'private' stamp: 'wernerkassens 3/27/2015 15:37'!
calcView
self checkResult.
aView := RTView new @ RTDraggableView.
aView canvas color: backgroundColor .
aView addMenu: ' Print' callback: [ self print ].
aView addMenu: 'In' callback: [ RTZoomInMove on: aView].
aView addMenu: 'Out' callback: [ RTZoomOutMove on: aView].
self boxesIntoView .
^aView! !

!BoxVisualizer methodsFor: 'private' stamp: 'wernerkassens 3/9/2015 10:03'!
calcZoomFactor
|ymin ymax d|
ymin:=Float infinity .
ymax:=ymin negated. 
usedResult do: [ :box| |i| 
	i:=box second. 
	ymin := ymin min: i inf.
	ymax := ymax max: i sup].
d:=ymax-ymin.
decimals:= (2-(d floorLog: 10)).
^zoomFactor :=(270/d)floor.! !

!BoxVisualizer methodsFor: 'private' stamp: 'wernerkassens 2/27/2015 08:49'!
checkResult
result ifNil:[self error:'Result is not set'].! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'wernerkassens 3/30/2015 09:03'!
color: aColor 
self checkResult.
color:=aColor.
self calcBuilder; updateWindow .
^color! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'wernerkassens 2/26/2015 17:44'!
dimensions
	^ dimensions! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'wernerkassens 3/30/2015 09:02'!
dimensions: anArrayOfDimension
"sets the 2 dimensions of the boxes that will be shown. by default the first 2 dimensions will be used"
self assert: anArrayOfDimension size=2.
dimensions := anArrayOfDimension.
result ifNotNil: [ self calcBuilder; updateWindow].
^dimensions ! !

!BoxVisualizer methodsFor: 'initialization' stamp: 'wernerkassens 3/27/2015 12:37'!
initialize 
dimensions := #(1 2).
color:=Color veryLightGray .
backgroundColor :=Color white .
withBorder :=true.
! !

!BoxVisualizer methodsFor: 'showing' stamp: 'WernerKassens 3/15/2016 20:33'!
print
|exp|
exp := (Smalltalk hasClassNamed: 'DCTRCanvasExporter') ifTrue: [ #DCTRCanvasExporter asClass] ifFalse: [ #RTCanvasExporter asClass ].
exp := exp canvas: aView canvas.
exp format: #png;
	fileName: ((UIManager default request: 'Please enter file name' initialAnswer: 'export.png') 
		ifNil: [ ^ nil ]).
exp export. 
! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'wernerkassens 2/27/2015 08:43'!
result
	^ usedResult! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'WernerKassens 2/25/2016 10:44'!
result: aCollectionOfBoxesOrBox
	result:= aCollectionOfBoxesOrBox class =IntervalBox 
		ifTrue:[aCollectionOfBoxesOrBox asSimpleBoxes]
		ifFalse:[aCollectionOfBoxesOrBox].
	self calcBuilder .
	^result! !

!BoxVisualizer methodsFor: 'showing' stamp: 'wernerkassens 3/29/2015 14:40'!
show
self checkResult.
^window:=aView open
! !

!BoxVisualizer methodsFor: 'showing' stamp: 'wernerkassens 2/28/2015 18:02'!
show: aTitle 
^self show setLabel: aTitle
! !

!BoxVisualizer methodsFor: 'showing' stamp: 'wernerkassens 3/30/2015 14:34'!
updateWindow
|oldTRMorph newCanvas|
window ifNil:[^self].
oldTRMorph :=window lastSubmorph. 
newCanvas :=aView canvas.
newCanvas camera: oldTRMorph trachelCanvas camera.
oldTRMorph trachelCanvas camera: nil."does not really help,it seems that oldTRMorph does not get garbage collected until window gets closed"
window replacePane: oldTRMorph with: newCanvas buildMorph.! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'wernerkassens 2/27/2015 08:51'!
view
self checkResult.
^aView ! !

!BoxVisualizer methodsFor: 'accessing' stamp: 'wernerkassens 3/30/2015 09:03'!
withBorder: aBoolean
self checkResult.
withBorder := aBoolean .
self calcBuilder; updateWindow .
^withBorder! !

Object subclass: #Constraint
	instanceVariableNames: 'block admissibleImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Basic'!

!Constraint commentStamp: 'WernerKassens 2/2/2016 11:17' prior: 0!
A Constraint consists of a block with one (!!) argument (which can be a SequenceableCollection of several variables , eg an IntervalBox) and of the admissible results of that block. the admissible results can by set via #min:, #max:, #equalToNumber:  or #admissibleImage: 
(for the methods in the protocol testing to work the admissibleImage needs to understand only #includes: and #intersection:, hence this could also be used for non-numerical constraints)
examples:
c:=Constraint block: [ :x | x - x squared ] . "--> a Constraint([ :x | x - x squared ] <= 0)"
c max:3.
c. "--> a Constraint([ :x | x - x squared ] <= 3) "
c min:3.
c. "--> a Constraint(3 <=[ :x |  x - x squared ])" 
c equalToNumber: 3.
c. "--> a Constraint([ :x | x - x squared ] = 3)" 
c admissibleImage: (RealInterval inf: 0 sup: 3).
c. "--> a Constraint(0 <= [ :x | x - x squared ] <= 3)"    
!

!Constraint class methodsFor: 'instance creation' stamp: 'wernerkassens 1/1/2015 13:37'!
block: aBlock
^self new block: aBlock; yourself ! !

!Constraint class methodsFor: 'instance creation' stamp: 'wernerkassens 1/1/2015 13:30'!
block: aBlock image: anInterval
^self new block: aBlock; admissibleImage: anInterval; yourself ! !

!Constraint methodsFor: 'accessing' stamp: 'wernerkassens 1/1/2015 13:26'!
admissibleImage
	^ admissibleImage! !

!Constraint methodsFor: 'accessing' stamp: 'WernerKassens 2/22/2016 20:02'!
admissibleImage: possibleValues
"possibleValues needs to understand #includes: and #intersection: for the tests (see protocol testing) to work, hence RealIntervals and IntervalUnions are possible, but not Numbers!! for Numbers use #equalToNumber:"
	^admissibleImage := possibleValues! !

!Constraint methodsFor: 'accessing' stamp: 'WernerKassens 3/8/2016 19:10'!
admissibleNumberForValue: aValue
"returns 0 if aValue is not admissible, 1 if it is partly admissible or undecidable and 2 if it is admissible"
^(self isAdmissibleValue: aValue) 
	ifTrue: [ 2 ] 
	ifFalse: [ (self isNotAdmissibleValue: aValue)
		ifTrue: [ 0 ] ifFalse: [ 1 ]  ]! !

!Constraint methodsFor: 'accessing' stamp: 'wernerkassens 1/1/2015 13:26'!
block
	^ block! !

!Constraint methodsFor: 'accessing' stamp: 'wernerkassens 1/1/2015 13:26'!
block: anObject
	block := anObject! !

!Constraint methodsFor: 'converting' stamp: 'WernerKassens 2/22/2016 20:05'!
enlargeToWidth: aNumber
^admissibleImage enlargeToWidth: aNumber! !

!Constraint methodsFor: 'accessing' stamp: 'wernerkassens 1/1/2015 13:34'!
equalToNumber: aNumber 
"alternative way to set admissibleImage "
^admissibleImage :=RealInterval fromNumber: aNumber  ! !

!Constraint methodsFor: 'initialize' stamp: 'wernerkassens 1/1/2015 13:36'!
initialize
	admissibleImage := RealInterval inf: Float infinity negated sup: 0.
	block := [:x|x].! !

!Constraint methodsFor: 'testing' stamp: 'WernerKassens 3/8/2016 19:05'!
isAdmissibleValue: aValue
^admissibleImage includes: (block value: aValue)! !

!Constraint methodsFor: 'testing' stamp: 'wernerkassens 1/1/2015 18:10'!
isNotAdmissibleValue: aValue
|x|
x:=admissibleImage intersection: (block value: aValue).
^x isNumber ifTrue: [ false ] ifFalse: [x isEmpty] ! !

!Constraint methodsFor: 'testing' stamp: 'WernerKassens 3/9/2016 02:55'!
isPerhapsAdmissibleValue: aValue

^(self isNotAdmissibleValue: aValue)not! !

!Constraint methodsFor: 'accessing' stamp: 'wernerkassens 1/1/2015 13:34'!
max: aNumber 
"alternative way to set admissibleImage "
^admissibleImage :=RealInterval inf: Float infinity negated sup: aNumber  ! !

!Constraint methodsFor: 'accessing' stamp: 'wernerkassens 1/1/2015 13:33'!
min: aNumber 
"alternative way to set admissibleImage "
^admissibleImage :=RealInterval inf: aNumber sup: Float infinity  ! !

!Constraint methodsFor: 'printing' stamp: 'wernerkassens 1/19/2015 18:09'!
printOn: aStream
|s|
   super printOn: aStream .
	aStream nextPut: $(.
	admissibleImage isRealInterval 
	ifTrue:[
	((admissibleImage inf ~= Float infinity negated)and: 
		[admissibleImage inf ~= admissibleImage sup ])ifTrue: 
			[ aStream print: admissibleImage inf; nextPutAll: ' <= ' ].
	s:=block asString.
	s:=(s copyReplaceAll: Character cr asString  with: ' ' asTokens:false) 
		"copyFrom: (s indexOf: $|)+2 to: (s size -2)".
	aStream nextPutAll: s.
	(admissibleImage sup=Float infinity )ifFalse: 
		[ (admissibleImage inf = admissibleImage sup) 
				ifTrue: [ aStream nextPutAll: ' = '] 
				ifFalse: [aStream nextPutAll: ' <= ']. 
			aStream print: admissibleImage sup ]]
	ifFalse:[ block printOn:aStream.
		aStream nextPutAll: ' : '.
		admissibleImage printOn:aStream.].
	aStream nextPut: $).
	! !

!Constraint methodsFor: 'printing' stamp: 'wernerkassens 1/3/2015 15:49'!
storeOn: aStream
	aStream nextPut: $(; nextPutAll: self class name;
		nextPutAll: ' block: '; print: block ;
		nextPutAll: ' image: '; store: admissibleImage;
		nextPut: $)! !

Object subclass: #FunctionRefinement0
	instanceVariableNames: 'function n interval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!FunctionRefinement0 commentStamp: 'WernerKassens 1/27/2016 16:44' prior: 0!
A FunctionRefinement0 is a naive implementation of a refinement of a function of _one_ var. it exists mainly for testing purposes.
example:
f:=[:x|x - x squared]. 
x:=RealInterval inf: 0.0 sup: 1.0.
f value:x . "--> [-1.0,1.0]"
ff:=FunctionRefinement0 function: f interval:x .
ff evaluate .  "--> [-0.0010000000000000009,0.251] "  
!

!FunctionRefinement0 class methodsFor: 'instance creation' stamp: 'wernerkassens 1/5/2015 11:25'!
function: aBlock interval: anInterval
^self new function: aBlock ;interval: anInterval;yourself  ! !

!FunctionRefinement0 class methodsFor: 'instance creation' stamp: 'wernerkassens 1/17/2015 10:33'!
function: aBlock interval: anInterval numberOfSplits: anInteger 
^self new function: aBlock ;interval: anInterval; numberOfSplits: anInteger; yourself    ! !

!FunctionRefinement0 methodsFor: 'operation' stamp: 'WernerKassens 2/9/2016 16:42'!
evaluate 
^(interval splitTimes: n) intervalCollect: function ! !

!FunctionRefinement0 methodsFor: 'accessing' stamp: 'wernerkassens 2/28/2015 13:34'!
function: aBlock
	^function := aBlock! !

!FunctionRefinement0 methodsFor: 'initialization' stamp: 'wernerkassens 1/5/2015 11:20'!
initialize
	super initialize.
	n := 1000.! !

!FunctionRefinement0 methodsFor: 'accessing' stamp: 'wernerkassens 2/28/2015 13:34'!
interval: anInt
	^interval := anInt! !

!FunctionRefinement0 methodsFor: 'accessing' stamp: 'wernerkassens 2/28/2015 13:35'!
numberOfSplits: anInteger
	^n := anInteger! !

Object subclass: #FunctionRefinement1
	instanceVariableNames: 'function box maximumIterations'
	classVariableNames: 'Version'
	poolDictionaries: ''
	category: 'Math-RealInterval-Algos'!

!FunctionRefinement1 commentStamp: 'wernerkassens 1/19/2015 17:29' prior: 0!
A FunctionRefinement1  is a  refinement of a function of  a box or RealInterval or IntervalUnion using the Skelboe-Moore algo.
example:
f:=[:x|x - x squared]. 
x:=RealInterval inf: 0.0 sup: 1.0.
f value:x . "--> [-1.0,1.0]"
ff:=FunctionRefinement1 function: f box:x.
ff evaluate .  "--> [-1.032869778594403e-8,0.2500211522783466] "
the theoretically best interval result would be [ 0,0.25 ]  which is nicely included in the result of #evaluate. !

!FunctionRefinement1 class methodsFor: 'instance creation' stamp: 'wernerkassens 1/19/2015 16:58'!
function: aBlock box: anIntervalBoxOrRealIntervalOrIntervalUnion
^self new function: aBlock ;box: anIntervalBoxOrRealIntervalOrIntervalUnion;yourself  ! !

!FunctionRefinement1 class methodsFor: 'accessing' stamp: 'WernerKassens 2/11/2016 15:58'!
skelboeMooreVersion
^Version ifNil: [ Version:=1]! !

!FunctionRefinement1 class methodsFor: 'accessing' stamp: 'wernerkassens 1/27/2015 16:24'!
skelboeMooreVersion: oneOrTwo
^Version :=oneOrTwo ! !

!FunctionRefinement1 methodsFor: 'accessing' stamp: 'wernerkassens 1/19/2015 16:58'!
box: anIntervalBoxOrRealIntervalOrIntervalUnion
^box := anIntervalBoxOrRealIntervalOrIntervalUnion! !

!FunctionRefinement1 methodsFor: 'operation' stamp: 'AutoDeprecationRefactoring 9/15/2017 16:42'!
evaluate
	| min max algo |
	algo := (self class skelboeMooreVersion = 1
		ifTrue: [ SkelboeMoore1 ]
		ifFalse: [ SkelboeMoore2 ]) function: function box: box.
	maximumIterations ifNotNil: [ :m | algo maximumIterations: m ].
	min := algo evaluate last inf.
	algo function: [ :x | (function value: x) negated ].
	max := algo evaluate last inf negated.
	^ RealInterval inf: min sup: max! !

!FunctionRefinement1 methodsFor: 'accessing' stamp: 'wernerkassens 1/17/2015 12:58'!
function: aBlock
^function := aBlock! !

!FunctionRefinement1 methodsFor: 'accessing' stamp: 'wernerkassens 1/17/2015 14:32'!
maximumIterations: anInteger 
^maximumIterations:= anInteger ! !

!Object methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 1/15/2015 14:09'!
isIntervalUnion
^false! !

!Object methodsFor: '*Math-RealInterval' stamp: 'wernerkassens 11/9/2014 18:20'!
isRealInterval
^false! !

Object subclass: #RealInterval
	instanceVariableNames: 'inf sup comments'
	classVariableNames: 'ConsistsOfFloatsOnly'
	poolDictionaries: ''
	category: 'Math-RealInterval-Basic'!

!RealInterval commentStamp: 'WernerKassens 2/2/2016 18:15' prior: 0!
a RealInterval is a closed interval of numbers where its infimum and supremum are both #Number's. if both are Float nan, it is empty. the numbers, it consists of, are reals if  ConsistsOfFloatsOnly is false and they are only Floats if ConsistsOfFloatsOnly is true. this differentiation affects only #split: at the moment (its just experimental, like the comments methods which are used very sparingly and dont move trough calculations at the moment. they would need extra logic for moving, but then i think they could be useful to get better results).
!

!RealInterval class methodsFor: 'instance creation' stamp: 'WernerKassens 2/24/2016 17:46'!
big
"to catch most practical numbers without producing infinities in further calculations"
^super new inf:  -1e10; sup: 1e10; yourself ! !

!RealInterval class methodsFor: 'accessing' stamp: 'wernerkassens 3/31/2015 13:06'!
consistsOfFloatsOnly
"experimental: decides whether an interval consists of reals or floats. only affects #split:  at the moment. class initialize sets it by default to false"
^ConsistsOfFloatsOnly ! !

!RealInterval class methodsFor: 'accessing' stamp: 'wernerkassens 3/31/2015 13:21'!
consistsOfFloatsOnly:aBoolean
"experimental: decides whether an interval consists of reals or floats. only affects #split:  at the moment (and only in a very rudimentary way). class initialize sets it by default to false. this is more of a heuristic than a mathematical decision  and trying to make this rigorous - eg by applying it to #difference: or in a more complete way to #split: - only introduces bugs that are not necessarily simple to track down."
^ConsistsOfFloatsOnly :=aBoolean! !

!RealInterval class methodsFor: 'instance creation' stamp: 'wernerkassens 12/13/2014 07:45'!
entire
^super new inf: 0 - Float infinity; sup: Float infinity; yourself ! !

!RealInterval class methodsFor: 'instance creation' stamp: 'wernerkassens 2/12/2015 21:56'!
fromNumber: aNumber
|n|
n:= aNumber asNumber .
^n isInfinite ifTrue: [self new] ifFalse: [super new inf: n;yourself] ! !

!RealInterval class methodsFor: 'instance creation' stamp: 'wernerkassens 12/6/2014 13:36'!
fromNumber: aNumber withUncertainty: d
|u|
u:=d abs.
^aNumber isInfinite ifTrue: [self new] ifFalse: [super new inf: aNumber- u;sup: aNumber + u;yourself] ! !

!RealInterval class methodsFor: 'instance creation' stamp: 'WernerKassens 2/24/2016 17:31'!
halfPi
^super new inf:  Float halfPi; sup: Float halfPi successor ; yourself ! !

!RealInterval class methodsFor: 'instance creation' stamp: 'wernerk 12/26/2014 10:22'!
inf: aNumber sup: anotherN
^(aNumber isNaN or: [ anotherN isNaN or:[ aNumber isInfinite and:  [aNumber =anotherN ]]])
	ifTrue: [ self new ] 
	ifFalse: [super new inf: aNumber;sup: anotherN;yourself ]! !

!RealInterval class methodsFor: 'class initialization' stamp: 'wernerkassens 2/10/2015 13:54'!
initialize
ConsistsOfFloatsOnly :=false.
! !

RealInterval initialize!

!RealInterval class methodsFor: 'instance creation' stamp: 'wernerkassens 12/13/2014 13:14'!
new
"an empty interval"
^super new inf: Float nan; yourself ! !

!RealInterval class methodsFor: 'instance creation' stamp: 'WernerKassens 2/24/2016 17:43'!
pi
"not yet used so far. i just thought, perhaps this could help for trigonometric functions."
^super new inf:  Float pi; sup: Float pi successor ; yourself ! !

!RealInterval class methodsFor: 'util' stamp: 'wernerkassens 12/10/2014 09:53'!
quadrant:aFloat
aFloat <=Float halfPi ifTrue: [ ^1 ].
aFloat <=Float pi ifTrue: [ ^2 ].
aFloat <=(Float halfPi + Float pi) ifTrue: [ ^3 ].
^4
! !

!RealInterval class methodsFor: 'instance creation' stamp: 'WernerKassens 2/24/2016 17:34'!
twoPi
^super new inf:  Float twoPi; sup: Float twoPi successor ; yourself ! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerkassens 1/15/2015 14:09'!
* anInt
|c|
(anInt isNumber and:[anInt isRealInterval not]) ifTrue: [^self * (RealInterval fromNumber: anInt) ] .
anInt isIntervalUnion ifTrue:[^anInt adaptToNumber: self andSend: #*].
(anInt isEmpty or: [self isEmpty ]) ifTrue: [ ^RealInterval new ] .
(self isZeroInterval or:[anInt isZeroInterval ])ifTrue: [ ^RealInterval inf: 0 sup: 0 ].
self isMixed 
 ifTrue: [ 
	anInt isMixed 
	ifTrue: [
		c:={inf * anInt inf. sup * anInt inf. inf * anInt sup. sup * anInt sup}.
		^RealInterval inf: c min sup: c max  ] 
	ifFalse: [ anInt positive 
		ifTrue: [
			 ^RealInterval inf: (self inf * anInt sup) sup: (self sup *anInt sup) ] 
		ifFalse:[
			 ^RealInterval inf: (self sup * anInt inf) sup: (self inf *anInt inf) ] ]] 
 ifFalse: [
	self positive 
		ifTrue: [ anInt isMixed ifTrue: [ ^anInt * self ] ifFalse: [ anInt positive
				 ifTrue: [ ^RealInterval inf: (self inf * anInt inf) sup: (self sup *anInt sup) ] 
				 ifFalse: [ ^RealInterval inf: (self sup * anInt inf) sup: (self inf *anInt sup) ] ] ] 
		ifFalse: [ anInt negative 
			ifTrue: [ ^RealInterval inf: (self sup * anInt sup) sup: (self inf *anInt inf) ] 
			ifFalse: [ ^anInt * self ] ]   ].
! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerkassens 1/15/2015 14:09'!
+ anInt
(anInt isNumber and:[anInt isRealInterval not]) ifTrue: [^(self + (RealInterval inf: anInt sup: anInt)) ] .
anInt isIntervalUnion ifTrue:[^anInt adaptToNumber: self andSend: #+].
^RealInterval inf: (inf +anInt inf) sup: sup+anInt sup! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerkassens 1/15/2015 14:09'!
- anInt
(anInt isNumber and:[anInt isRealInterval not]) ifTrue: [^self - (RealInterval inf: anInt sup: anInt) ] .
anInt isIntervalUnion ifTrue:[^anInt adaptToNumber: self andSend: #-].
^RealInterval inf: (inf - anInt sup) sup: sup-anInt inf! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerkassens 1/15/2015 14:09'!
/ anInt
(anInt isNumber and:[anInt isRealInterval not]) ifTrue: [^self / (RealInterval fromNumber: anInt) ].
anInt isIntervalUnion ifTrue:[^anInt adaptToNumber: self andSend: #/].
(anInt isEmpty or: [self isEmpty ]) ifTrue: [ ^RealInterval new ] .
(anInt isZeroInterval )ifTrue: [ ^RealInterval new comments:'zeroDivide';yourself].
self isMixed 
 ifTrue: [ 
	anInt isMixed 
	ifTrue: [^RealInterval entire  ] 
	ifFalse: [ anInt positive 
		ifTrue: [(anInt inf = 0) 
			ifTrue: [ ^RealInterval entire] 
			ifFalse: [^RealInterval inf: (self inf / anInt inf) sup: (self sup / anInt inf) ] ] 
		ifFalse:[(anInt sup=0)
			ifTrue: [ ^RealInterval entire ] 
			ifFalse:  [^RealInterval inf: (self sup / anInt sup) sup: (self inf / anInt sup) ] ] ] ]
 ifFalse: [
	self positive 
		ifTrue: [( inf=0)	"P0"
			ifTrue: [ anInt isMixed 
				ifTrue: [ ^RealInterval entire ] 
				ifFalse: [ anInt positive 
					ifTrue: [ (anInt inf=0) 
						ifTrue: [ ^RealInterval inf: 0 sup: Float infinity ] 
						ifFalse: [ ^RealInterval inf: 0 sup: (self sup / anInt inf) ]  ] 
					ifFalse: [ (anInt sup=0)	"anInt isNegative"
						ifTrue: [ ^RealInterval inf: Float infinity negated sup: 0 ] 
						ifFalse: [ ^RealInterval inf: (self sup/anInt sup) sup: 0 ]  ]  ] ] 
			ifFalse:[ anInt isMixed 			"P1"
				ifTrue: [ ^(RealInterval inf: Float infinity negated sup: (self inf/anInt inf))union: 
					 (RealInterval inf: (self inf/anInt sup) sup: Float infinity) ] 
				ifFalse:[ anInt positive 
					ifTrue: [(anInt inf=0)
						ifTrue: [ ^RealInterval inf: (self inf/anInt sup) sup: Float infinity ] 
						ifFalse: [ ^RealInterval inf: (self inf/anInt sup) sup: (sup/anInt inf) ]  ] 
					ifFalse:[(anInt sup=0)	"anInt isNegative"
						ifTrue: [ ^RealInterval inf: Float infinity negated sup: (inf/anInt inf) ]
						 ifFalse: [ ^RealInterval inf: (sup/anInt sup) sup: (inf/anInt inf) ] ] ] ] ]
		ifFalse: [self negative 
		  ifTrue: [( sup=0)	"N0"
			ifTrue: [ anInt isMixed 
				ifTrue: [ ^RealInterval entire ] 
				ifFalse: [ anInt positive 
					ifTrue: [ (anInt inf=0) 
						ifTrue: [ ^RealInterval inf: Float infinity negated sup: 0 ] 
						ifFalse: [ ^RealInterval inf: (inf / anInt inf) sup: 0 ]  ] 
					ifFalse: [ (anInt sup=0)	"anInt isNegative"
						ifTrue: [ ^RealInterval inf:  0 sup: Float infinity ] 
						ifFalse: [ ^RealInterval inf: 0 sup: (inf/anInt sup) ]  ]  ] ] 
			ifFalse:[ anInt isMixed 			"N1"
				ifTrue: [ ^(RealInterval inf: Float infinity negated sup: (sup/anInt sup))union: 
						(RealInterval inf: (sup/anInt inf) sup: Float infinity) ] 
				ifFalse:[ anInt positive 
					ifTrue: [(anInt inf=0)
						ifTrue: [ ^RealInterval inf: Float infinity negated sup: (sup/anInt sup) ] 
						ifFalse: [ ^RealInterval inf: (inf/anInt inf) sup: (sup/anInt sup) ]  ] 
					ifFalse:[(anInt sup=0)	"anInt isNegative"
						ifTrue: [ ^RealInterval inf: (sup/anInt inf)  sup: Float infinity  ]
						 ifFalse: [ ^RealInterval inf: (sup/anInt inf) sup: (inf/anInt sup) ] ] ] ]]
		 ]].
! !

!RealInterval methodsFor: 'arithmetic' stamp: 'WernerKassens 2/7/2016 09:08'!
// anInt
	"Integer quotient defined by division with truncation toward negative 
	infinity.  \\ answers the remainder 
	from this division."
	"this is Pharos definition and the implementation of course follows
	this definition, but i wonder a bit whether it wouldnt be better for
	the interval definition to assume that the integer quotient is only
	defined on integers?"
	^(self / anInt) floor! !

!RealInterval methodsFor: 'comparing' stamp: 'wernerkassens 1/15/2015 14:09'!
= anObject
	^anObject isRealInterval
		ifFalse: [anObject isIntervalUnion 
			ifTrue: [anObject =self] 
			ifFalse:[anObject isNumber 
				ifTrue: [ self adaptToNumber: anObject  andSend: #= ] 
				ifFalse: [false]]]
		ifTrue: [  ((inf=anObject inf)and:[sup=anObject sup])or:[(self isEmpty and:[anObject isEmpty])] ]
! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerkassens 12/22/2014 19:11'!
\\ aNumber 
	"modulo. Remainder defined in terms of //. Answer a Number with the 
	same sign as aNumber. at the moment aNumber cant be an interval but this should be changed"

|barrier n bplusn|
self isEmpty ifTrue: [ ^RealInterval new ].
(aNumber isNumber not or:[aNumber isRealInterval ])ifTrue:[self error].
n:=aNumber abs.
self width>=n ifTrue: [ ^(aNumber >0) ifTrue: [ RealInterval inf: 0 sup: aNumber ] ifFalse:[ RealInterval inf: aNumber sup:0 ] ].
barrier :=(inf//aNumber * aNumber) .
bplusn :=barrier +n.
^aNumber >=0 
	ifTrue: [(bplusn <= sup ) 
		ifTrue: [ (RealInterval inf: (inf - barrier)   sup:  aNumber  ) union: (RealInterval inf:  0 sup:( sup - bplusn ) )] 
		ifFalse:[ RealInterval inf: inf - barrier  sup: sup - barrier ].]
	ifFalse: [(barrier < sup ) 
		ifTrue: [ (RealInterval inf: (inf - barrier )   sup:  0  ) union: (RealInterval inf:  aNumber sup:( sup - bplusn ) )] 
		ifFalse:[ RealInterval inf: inf - barrier  sup: sup - barrier ].]! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerk 12/26/2014 12:37'!
abs
|i s|
i:=(inf <=0) ifTrue:[self class inf: inf sup: (sup min: 0)] ifFalse:[RealInterval new].
s:=(sup>=0) ifTrue:[self class inf: (inf max:0) sup: sup] ifFalse:[RealInterval new].
^i negated union:s! !

!RealInterval methodsFor: 'double dispatching' stamp: 'wernerk 12/26/2014 12:40'!
adaptToNumber: rcvr andSend: selector
(rcvr isInfinite and: [ #(#max: #min:) includes: selector]) ifTrue: [ ^self perform: selector with: rcvr  ].
^(self class inf: rcvr sup: rcvr) perform: selector with: self! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 12/11/2014 12:30'!
arcCos
(self isEmpty or:[(sup< -1)or:[inf>1]])ifTrue: [ ^RealInterval new ].
^ RealInterval inf: (sup min:1) arcCos sup: (inf max: -1) arcCos ! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 12/11/2014 12:32'!
arcSin
(self isEmpty or:[(sup< -1)or:[inf>1]])ifTrue: [ ^RealInterval new ].
^ RealInterval inf: (inf max: -1) arcSin sup: (sup min:1) arcSin ! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerk 12/26/2014 12:39'!
arcTan
^ self class inf: inf arcTan sup: sup arcTan ! !

!RealInterval methodsFor: 'converting' stamp: 'wernerkassens 12/26/2014 17:23'!
asNumber
^self isNumber ifTrue: [sup] ifFalse: [ self]! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 12/6/2014 14:15'!
between: min and: max 
	^(self isEmpty)or: [inf >= min and: [sup  <= max]]! !

!RealInterval methodsFor: 'truncation' stamp: 'wernerkassens 1/15/2015 14:09'!
ceiling
|i|
self isEmpty ifTrue: [ ^RealInterval new ].
i:=self isFinite  
	ifTrue: [ IntervalUnion withAll: (inf ceiling to: sup ceiling)] 
	ifFalse:[( i:= inf isInfinite 
		ifTrue:  [ self copy sup: (self sup isInfinite ifTrue: [ sup ] ifFalse:[ sup ceiling]); yourself ]
		ifFalse: [ self copy inf: self inf ceiling; yourself ]) comments:'onlyIntegers'; yourself ].
^(i isIntervalUnion and: [i size=1]) ifTrue: [ i first ] ifFalse: [ i ]
! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 11/11/2014 13:59'!
comments
^comments! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 11/15/2014 16:44'!
comments:aString
^comments add: aString ! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 12/10/2014 13:46'!
cos
^(self + Float halfPi) sin! !

!RealInterval methodsFor: 'accessing' stamp: 'WernerKassens 2/11/2016 04:30'!
cutPoint
|i|
^self isEmpty 
	ifTrue: [ Float nan ] 
	ifFalse: [ self isMixed 
		ifTrue: [ 0.0 ] 
		ifFalse: [ self isNumber 
			ifTrue: [ Float nan ] 
			ifFalse: [ (inf closeTo: 0) 
				ifTrue:[(sup=Float infinity)
					ifTrue: [ 1.0 ] 
					ifFalse: [ sup +inf /2.0 ] ]
				ifFalse:[(sup closeTo: 0) 
					ifTrue: [ (inf=Float infinity negated ) 
						ifTrue: [ -1.0 ] 
						ifFalse: [ sup +inf /2.0 ] ] 
					ifFalse:[ self isFinite 
						ifTrue: [ i:=inf sign * (inf * sup)sqrt. ((i=sup) or: [i=inf])ifTrue: [ i:=inf+sup/2 ] ifFalse:[i] ] 
						ifFalse: [ (self sup=Float infinity) 
							ifTrue: [ inf * 10.0 ] 
							ifFalse: [ sup *10.0 ] ] ] ] ] ] ]! !

!RealInterval methodsFor: 'set operations' stamp: 'wernerkassens 2/27/2015 16:56'!
difference: anInt 
"at the moment not dependent on onlyfloats as this would introduce bugs. should be done very carefully, if at all"
self=anInt ifTrue:[^RealInterval new].
(anInt isNumber or: [self isEmpty or: [anInt isEmpty]] ) ifTrue: [^self] .
anInt isIntervalUnion ifTrue:[^(IntervalUnion with:self) difference: anInt ].
^anInt inf >sup 
	ifTrue:[self]
	ifFalse:[(anInt inf <=inf)
		ifTrue: [ anInt sup<sup 
			ifTrue: [RealInterval inf: (inf max: anInt sup) sup:sup ] 
			ifFalse: [ RealInterval new ] ]
		ifFalse:[ anInt sup < sup 
			ifTrue: [ (RealInterval inf: inf sup: anInt inf)union: (RealInterval inf: anInt sup sup:sup) ] 
			ifFalse:[ RealInterval inf: inf sup: anInt inf ] ] ].
! !

!RealInterval methodsFor: 'converting' stamp: 'WernerKassens 3/16/2016 19:14'!
enlargeToWidth: aNumber
| mp hw |
	mp := self midPoint.
	mp =0 
		ifTrue:[self width < aNumber 
			ifTrue:[hw := 1]
			ifFalse: [ ^ self ]]
		ifFalse:[self width / mp abs < aNumber 
			ifTrue:[hw := mp abs]
			ifFalse: [ ^ self ]].
	hw := hw * aNumber / 2.0.
	inf := mp - hw.
	sup := mp + hw! !

!RealInterval methodsFor: 'comparing' stamp: 'wernerkassens 12/26/2014 17:53'!
equalsTo: anIntervall 
anIntervall isRealInterval ifFalse:[^self adaptToNumber: anIntervall andSend: #equalsTo: ].
^((inf=anIntervall inf)or: [inf equalsTo: anIntervall inf]) and:[(sup=anIntervall sup)or: [sup equalsTo: anIntervall sup]]! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerk 12/26/2014 12:41'!
exp
^ self class inf: inf exp sup: sup exp ! !

!RealInterval methodsFor: 'truncation' stamp: 'wernerkassens 1/15/2015 14:09'!
floor
|i|
self isEmpty ifTrue: [ ^RealInterval new ].
i:=self isFinite  
	ifTrue: [ IntervalUnion withAll: (inf floor to: sup floor) ] 
	ifFalse:[( i:= inf isInfinite 
		ifTrue:  [ self copy sup: (self sup isInfinite ifTrue: [ sup ] ifFalse:[ sup floor]); yourself ]
		ifFalse: [ self copy inf: self inf floor; yourself ]) comments:'onlyIntegers'; yourself ].
^(i isIntervalUnion and: [i size=1]) ifTrue: [ i first ] ifFalse: [ i ]
! !

!RealInterval methodsFor: 'truncation' stamp: 'wernerkassens 12/22/2014 15:57'!
fractionPart
	|s|
^self isMixed 
	ifTrue: [ s:=self split: 0.
		s first fractionPart union: s second fractionPart] 
	ifFalse: [self negative 
		ifTrue: [ self negated privateFractionPart negated] 
		ifFalse:[ self privateFractionPart. ] ].
! !

!RealInterval methodsFor: 'comparing' stamp: 'wernerkassens 12/4/2014 17:24'!
hash
^inf=sup ifTrue: [ inf hash ] ifFalse: [ inf hash hashMultiply bitXor: sup hash ]	"isNumber does not work here!!"! !

!RealInterval methodsFor: 'set operations' stamp: 'wernerkassens 11/28/2014 09:39'!
hull
^self! !

!RealInterval methodsFor: 'set operations' stamp: 'wernerkassens 9/23/2017 07:55'!
hull: anInt 
"this somewhat illogically accepts infinite numbers, which i found often useful."
(anInt isNumber and:[anInt isRealInterval not]) ifTrue: 
	[^anInt isInfinite 
		ifFalse: [self hull: (RealInterval fromNumber: anInt)]
		ifTrue:[ RealInterval inf: (inf min: anInt) sup:(anInt max: sup)] ].
self isEmpty ifTrue: [^anInt ].
anInt isEmpty ifTrue: [^self ].
anInt isIntervalUnion ifTrue: [ ^anInt hull:self ].
^RealInterval inf: (inf min: anInt inf) sup:(anInt sup max: sup)
! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 1/15/2015 14:09'!
includes: aNumberOrInterval
aNumberOrInterval isIntervalUnion 
	ifTrue: [ ^aNumberOrInterval allSatisfy: [:i|self includes: i]].
^ aNumberOrInterval between: inf and: sup! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 12/11/2014 14:24'!
inf 
^ inf  ! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 12/13/2014 16:47'!
inf: aNumber
"if aNumber > sup then an empty RealInterval will be returned"
^ inf:= sup 
	ifNil: [ sup:=aNumber ] 
	ifNotNil: [sup isNaN 
		ifTrue: [ aNumber isInfinite 
			ifTrue: [ (aNumber <0) 
				ifTrue: [sup:= Float infinity. 0-Float infinity] 
				ifFalse: [sup:= Float nan]] 
			ifFalse: [sup:=aNumber] ] 
		ifFalse:[ ((aNumber <=sup)and:[aNumber < Float infinity ]) ifTrue: [ aNumber ] ifFalse:[sup:= Float nan]]] .! !

!RealInterval methodsFor: 'converting' stamp: 'wernerkassens 3/11/2015 17:19'!
inflate
^self class inf: inf asFloat predecessor sup: sup asFloat successor ! !

!RealInterval methodsFor: 'initialization' stamp: 'wernerkassens 11/11/2014 13:58'!
initialize 
comments:=OrderedCollection new.! !

!RealInterval methodsFor: 'set operations' stamp: 'wernerkassens 2/27/2015 16:56'!
intersection: anInt 
"at the moment not dependent on onlyfloats as this would introduce bugs. should be done very carefully, if at all"
|l u|
(anInt isNumber and:[anInt isRealInterval not]) ifTrue:[
	^(anInt between: inf and: sup) 
		ifTrue:[anInt ]  
		ifFalse: [ RealInterval new ] ].
(self isEmpty or: [anInt isEmpty])ifTrue: [^RealInterval new ].
anInt isIntervalUnion ifTrue:[^anInt adaptToNumber: self andSend: #intersection:].
l:=(inf max: anInt inf).
u:=(sup min: anInt sup).
^ l <= u ifTrue: [ RealInterval inf: l sup: u ] ifFalse:[RealInterval new] 
! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 12/22/2014 16:01'!
isAnInteger 
"can not be named isInteger because of implementation of #= in Integer, but this check is necessary nevertheless. could be corrected with a little workaround; am just too lazy at the moment"
|i|
i:=self asNumber .
^i isInfinite not and: [i \\ 1= 0]! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 1/11/2015 10:47'!
isAtomic
^sup<=inf asFloat successor! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 12/25/2014 09:46'!
isEmpty
^inf isNaN "or:" "and:" " [ sup isNaN  ]"
"much faster without the last part and used very often"! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 12/23/2014 11:24'!
isFinite
^(self isInfinite or:[self isEmpty])not ! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 12/23/2014 11:22'!
isInfinite
^(inf =Float infinity negated)or: [ sup=Float infinity ]! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 11/8/2014 11:54'!
isMixed
^(inf <0)and: [ sup>0 ]! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 1/11/2015 10:47'!
isNumber
^sup=inf! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 11/9/2014 18:07'!
isRealInterval 
^true! !

!RealInterval methodsFor: 'testing' stamp: 'wernerk 12/26/2014 12:57'!
isZero
^false
"for divide by zero test in number/interval. nonsense but necessary in this form. you can use #isZeroInterval instead!!"! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 11/12/2014 16:25'!
isZeroInterval
^(inf =0)and: [ sup=0 ]! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 12/6/2014 11:55'!
ln
^sup<0 
	ifTrue:[  RealInterval new]
	ifFalse:[ RealInterval inf: ((inf<0) ifTrue: [Float infinity negated ] ifFalse:[inf ln]) sup: sup ln]! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 12/6/2014 11:55'!
log
^sup<0 
	ifTrue:[  RealInterval new]
	ifFalse:[ RealInterval inf: ((inf<0) ifTrue: [Float infinity negated ] ifFalse:[inf log]) sup: sup log]! !

!RealInterval methodsFor: 'comparing' stamp: 'wernerkassens 1/15/2015 14:09'!
max: anObject
	^anObject isRealInterval
		ifFalse: [(anObject isNumber) 
			ifTrue: [
				anObject isInfinite 
					ifTrue: [ ^(anObject >0) ifTrue: [ Float infinity ] ifFalse: [ self ] ] 
					ifFalse: [ self adaptToNumber: anObject andSend: #max:] ] 
			ifFalse:[(anObject isIntervalUnion)
				ifTrue: [ anObject max: self ] 
				ifFalse: [ self error: 'max:'] ]]
		ifTrue: [ (self isEmpty or:[anObject isEmpty])
			ifTrue:  [ RealInterval new ] 
			ifFalse: [  RealInterval inf: (inf max: anObject inf) sup:(sup max:anObject sup) ] ]
! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 1/17/2015 12:02'!
midPoint
^self isFinite ifTrue: [ sup +inf /2.0 ] ifFalse: [self cutPoint ]! !

!RealInterval methodsFor: 'comparing' stamp: 'wernerkassens 1/15/2015 14:09'!
min: anObject
	^anObject isRealInterval
		ifFalse: [anObject isNumber 
			ifTrue: [
				anObject isInfinite 
					ifTrue: [ ^(anObject >0) ifTrue: [ self ] ifFalse: [ Float infinity negated] ] 
					ifFalse: [self adaptToNumber: anObject  andSend: #min:] ]
			ifFalse:[(anObject isIntervalUnion)
				ifTrue: [ anObject min: self ] 
				ifFalse: [ self error: 'min:'] ]]
		ifTrue: [ (self isEmpty or:[anObject isEmpty])
			ifTrue:  [ RealInterval new ] 
			ifFalse: [  RealInterval inf: (inf min: anObject inf) sup:(sup min:anObject sup) ] ]
! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerkassens 11/15/2014 13:58'!
negated
^self class inf: sup negated sup: inf negated! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 12/22/2014 15:57'!
negative
^(inf <0)and: [ sup<=0 ]! !

!RealInterval methodsFor: 'testing' stamp: 'wernerkassens 12/22/2014 15:58'!
positive
^(inf >=0)and: [ sup>0 ]! !

!RealInterval methodsFor: 'copying' stamp: 'wernerkassens 11/15/2014 14:50'!
postCopy
	super postCopy.
	comments := comments copy! !

!RealInterval methodsFor: 'printing' stamp: 'wernerkassens 11/25/2014 10:53'!
printOn: aStream
	self isEmpty ifTrue: [ ^aStream nextPutAll: '[empty]' ].
	aStream nextPut: $[.
	inf printOn: aStream.
	aStream nextPut: $,.
	sup printOn: aStream.
	aStream nextPut: $].! !

!RealInterval methodsFor: 'private' stamp: 'wernerkassens 12/6/2014 11:56'!
privateFractionPart
"works for positive recipient"
	|distance lower upper|
self isEmpty  ifTrue: [ ^RealInterval new ] .
upper :=sup isInfinite ifFalse: [sup truncated] ifTrue:[sup] .
lower :=inf isInfinite ifFalse: [inf truncated] ifTrue:[inf].
distance := upper - lower .
upper :=sup - upper.
lower :=inf - lower.
^distance >1 
	ifTrue:[RealInterval inf: 0 sup: 1]
	ifFalse: [distance =0 
		ifTrue: [RealInterval inf: lower sup: upper ]
		ifFalse: [(RealInterval inf: 0 sup: upper)union:(RealInterval inf: lower sup: 1 )]]. "distance=1"! !

!RealInterval methodsFor: 'private' stamp: 'wernerkassens 12/20/2014 17:07'!
privateRaisedBig: anInt 
"self>=1"
(self isEmpty or:[anInt isEmpty ])ifTrue:[^RealInterval new].
^RealInterval inf: (inf raisedTo: anInt inf) 
	sup: (anInt sup isInfinite ifTrue: [ (sup>1) ifTrue:[Float infinity]ifFalse:[1] ] ifFalse: [sup raisedTo: anInt sup])! !

!RealInterval methodsFor: 'private' stamp: 'wernerkassens 12/12/2014 16:50'!
privateRaisedSmall: anInt 
"self<=1"
(self isEmpty or:[anInt isEmpty ])ifTrue:[^RealInterval new].
((self=0)and:[(anInt ~=1)and: [anInt includes:  1]])ifTrue: [ ^0 union:1 ].
^RealInterval inf: (inf raisedTo: anInt sup) sup: (sup raisedTo: anInt inf)! !

!RealInterval methodsFor: 'private' stamp: 'wernerkassens 12/10/2014 15:44'!
privateRaisedTo: anInt 
"anInt isPositive"
|s|
(inf<1 and:[sup>1])ifTrue: [ s:=self split: 1. ^(s first privateRaisedSmall: anInt)union: (s second privateRaisedBig: anInt)  ].
^inf<1 ifTrue:[self privateRaisedSmall: anInt] ifFalse:[self privateRaisedBig: anInt]! !

!RealInterval methodsFor: 'private' stamp: 'wernerk 12/26/2014 12:42'!
privateRaisedToInteger: anInteger
|r r1 r2|
(anInteger=0)ifTrue: [ ^self class fromNumber: 1 ].
r1:=inf raisedToInteger: anInteger abs.
r2:= sup raisedToInteger: anInteger abs.
r1>r2 ifTrue: [ r:=r1.r1:=r2.r2:=r ].
r:= self class inf: r1 sup: r2.
(anInteger<0) ifTrue: [^ r reciprocal ].
^ r
! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 12/25/2014 09:08'!
projectionFrom: aNumber
"returns the nearest number in the receiver of the same type as aNumber, or Float nan if such a
number does not exist"
| b x|
(aNumber isNaN or:[self isEmpty ]) ifTrue: [ ^Float nan].
(self includes: aNumber) ifTrue:[^aNumber].
b:=aNumber<inf.
aNumber isFloat ifTrue: [ ^ b ifTrue: [ inf asFloat] ifFalse: [ sup asFloat ] ].
aNumber isInteger ifTrue: [ b 
	ifTrue: [
		x:=inf asInteger.
		^(self includes: x)
			ifTrue: [ x ] 
			ifFalse:[ x:=x+1. (self includes: x) ifTrue: [x] ifFalse:[Float nan]] ]
	ifFalse: [ 
		x:=sup asInteger.
		^(self includes: x)
			ifTrue: [ x ] 
			ifFalse:[ x:=x-1. (self includes: x) ifTrue: [x] ifFalse:[Float nan]] ] ].
aNumber isFraction  ifTrue: [ b 
	ifTrue: [
		x:=inf asFraction .
		^(self includes: x)
			ifTrue: [ x ] 
			ifFalse:[ 
				x:=inf asFloat successor asFraction . 
				(self includes: x) ifTrue: [x] ifFalse:[Float nan]] ]
	ifFalse: [ 
		x:=sup asFraction.
		^(self includes: x)
			ifTrue: [ x ] 
			ifFalse:[ 
				x:=inf asFloat predecessor asFraction .  
				(self includes: x) ifTrue: [x] ifFalse:[Float nan]] ] ].
	self error:'bug in projectionFrom:'.! !

!RealInterval methodsFor: 'set operations' stamp: 'wernerkassens 3/27/2015 18:27'!
quasiUnion: anInt

^ self union: anInt! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerkassens 11/30/2014 13:38'!
quo: anInt 
	"Integer quotient defined by division with truncation toward zero. "

	^(self / anInt) truncated! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 1/17/2015 12:21'!
raisedTo: anInt 
|i u l s|
self isEmpty ifTrue: [ ^RealInterval new ].
anInt isIntervalUnion ifTrue:[^anInt adaptToNumber: self andSend: #raisedTo:].
((sup<0)and: [anInt isInteger not and: [anInt isAnInteger not]]) ifTrue: [ ^RealInterval new ].
s:=RealInterval inf: (inf max:0) sup: sup.
anInt isNumber 
	ifFalse: [ 
		anInt isEmpty ifTrue: [ ^RealInterval new ].
		i:=anInt splitAtZero.
		^(s privateRaisedTo: i first negated)reciprocal union: (s privateRaisedTo: i second)  ]
	ifTrue:[
		i:=anInt asNumber .
		(i isInfinite not and: [i \\ 1= 0]) ifTrue:[i:=i asInteger].
		i isInteger 
			ifTrue: [ ^self raisedToInteger: i ] 
			ifFalse:[
				l:=((s inf =0)ifTrue: [ Float infinity ] ifFalse: [s inf raisedTo: i]).
				u:=((s sup =0) 
					ifTrue: [(s inf =0) 
						ifTrue: [^RealInterval inf: 0 sup: 0  ]  
						ifFalse: [Float infinity  negated] ]  
					ifFalse: [s sup raisedTo: i]).
				l>u ifTrue: [i:=l.l:=u.u:=i ].
				((s includes: 1)and:[1<l]) ifTrue:[l:=1].
				^RealInterval inf: l sup: u ]  ].
! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 1/17/2015 12:21'!
raisedToInteger: anInteger
|i r|
self isEmpty ifTrue: [ ^RealInterval new ].
anInteger isIntervalUnion ifTrue:[^anInteger adaptToNumber: self andSend: #raisedToInteger:].
i:=anInteger isRealInterval 
	ifFalse: [anInteger ]
	ifTrue:[ anInteger isEmpty ifTrue: [ ^RealInterval new] .
			anInteger asNumber].
i isInteger ifFalse:[self error: i asString,' is no Integer'].
(i=0)ifTrue: [ ^RealInterval fromNumber: 1 ].
self isZeroInterval ifTrue: [ ^RealInterval fromNumber: 0 ].
^self isMixed 
	ifTrue:[ r:=self splitAtZero .
			(r first privateRaisedToInteger:i)union: (r second privateRaisedToInteger:i)]
	ifFalse: [ self privateRaisedToInteger: i ].
! !

!RealInterval methodsFor: 'arithmetic' stamp: 'wernerk 12/26/2014 12:31'!
reciprocal
^(self class fromNumber:1)/self! !

!RealInterval methodsFor: 'truncation' stamp: 'wernerkassens 1/15/2015 14:09'!
rounded
|i|
self isEmpty ifTrue: [ ^RealInterval new ].
i:=self isFinite  
	ifTrue: [ IntervalUnion withAll: (inf rounded to: sup rounded)] 
	ifFalse:[( i:= inf isInfinite 
		ifTrue:  [ self copy sup: (self sup isInfinite ifTrue: [ sup ] ifFalse:[ sup rounded]); yourself ]
		ifFalse: [ self copy inf: self inf rounded; yourself ]) comments:'onlyIntegers'; yourself ].
^(i isIntervalUnion and: [i size=1]) ifTrue: [ i first ] ifFalse: [ i ]
! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 1/15/2015 13:55'!
sign
|c|
self isEmpty ifTrue: [ ^RealInterval new ].
c:=OrderedCollection new.
(inf<0)ifTrue: [ c add: -1 ].
(self includes: 0)ifTrue: [ c add: 0 ].
(sup>0)ifTrue: [ c add: 1 ].
^c size=1 ifTrue: [ c first ] ifFalse: [IntervalUnion  withAll: c] 
	! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 3/29/2015 10:16'!
simpleSign
"does never return 0. for '0 sign' it returns 1. calculations can become much faster than with #sign!!"
|c|
self isEmpty ifTrue: [ ^RealInterval new ].
c:=OrderedCollection new.
(inf<0)ifTrue: [ c add: -1 ].
(sup>0)ifTrue: [ c add: 1 ].
^c size=1 
	ifTrue: [ c first ] 
	ifFalse: [c size =0 
		ifTrue:[1] 
		ifFalse: [IntervalUnion  withAll: c]] 
	! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 12/22/2014 19:11'!
sin
|l u distant q1 q2|
self isEmpty ifTrue: [ ^RealInterval new ].
self width>=Float twoPi ifTrue: [ ^RealInterval inf: -1 sup: 1 ].
l:=inf//Float twoPi .
u:=sup//Float twoPi .
distant :=l~=u.
l:=inf-(l * Float twoPi ).
u:=sup-(u * Float twoPi ).
q1:=self class quadrant: l.		
q2:=self class quadrant: u.	
((q1=q2 and:[distant ])or:[(q1=1and:[q2=4])or:[q1=3 and:[q2=2] ]]	)ifTrue: [ ^RealInterval inf: -1 sup: 1 ].
((q1=1 and:[q2=1 ])or:[(q1=4and:[q2=4])or:[q1=4 and:[q2=1] ]]) ifTrue:[^RealInterval inf: inf sin sup: sup sin ].
((q1=2 and:[q2=2 ])or:[(q1=3and:[q2=3])or:[q1=2 and:[q2=3] ]]) ifTrue:[^RealInterval inf: sup sin sup: inf sin ].
((q1=1 and:[q2=2 ])or:[(q1=1and:[q2=3])or:[(q1=4 and:[q2=3])or: [q1=4 and:[q2=2]] ]]) ifTrue:[^RealInterval inf: (inf sin min: sup sin) sup: 1 ].
^RealInterval inf: -1 sup: (inf sin max: sup sin) 
! !

!RealInterval methodsFor: 'converting' stamp: 'wernerkassens 1/17/2015 12:31'!
split
^self split: self cutPoint .
! !

!RealInterval methodsFor: 'converting' stamp: 'wernerkassens 1/17/2015 12:29'!
split:at
(at<inf or:[at>sup]) ifTrue: [ ^nil ].
self isAtomic ifTrue: [ ^(ConsistsOfFloatsOnly and:[self isNumber not])
	ifFalse: [ nil ] 
	ifTrue:[ 	Array with: (self class fromNumber: inf) with: (self class fromNumber: sup)] ]
  ifFalse:[(at=inf or:[at=sup])ifTrue:[^nil]].
^Array  with: (self class inf: inf sup: at) with: (self class inf: at sup: sup)! !

!RealInterval methodsFor: 'converting' stamp: 'wernerkassens 1/18/2015 13:58'!
splitAtZero
"split into a negative and a positive part. result is different from #split:0 insofar as it always returns an Array"
^self isMixed 
	ifTrue: [ Array  with: (self class inf: inf sup: 0) with: (self class inf: 0 sup: sup) ] 
	ifFalse:[self negative 
		ifTrue: [ Array with: self with: RealInterval  new ] 
		ifFalse:  [ Array with: RealInterval new with: self ]  ]! !

!RealInterval methodsFor: 'converting' stamp: 'wernerkassens 1/17/2015 13:57'!
splitTimes:anInteger
|i s w c|
w:=self width / anInteger.
i:=inf.
c:=OpenIntervalUnion  new:anInteger .
1 to: anInteger do:[:n|
	s :=  inf+ ( n * w ).
	c add: (self class inf: i sup: s).
	i:=s].
c last sup: sup.
^c! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 12/6/2014 11:57'!
sqrt
(self isEmpty or: [sup <0]) ifTrue: [ ^RealInterval new ].
sup=0 ifTrue:[^0].
^self isMixed ifTrue: [ RealInterval inf: 0 sup: (sup sqrt) ] ifFalse: [ RealInterval inf: inf sqrt sup: sup sqrt ]
	! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerk 12/26/2014 12:28'!
squared
^(self includes: 0) 
	ifTrue: [ self class inf: 0 sup: ((sup abs>inf abs) ifTrue: [ sup squared ] ifFalse: [ inf squared] )] 
	ifFalse: [ self*self ]
	! !

!RealInterval methodsFor: 'printing' stamp: 'wernerkassens 11/23/2014 10:09'!
storeOn: aStream
	aStream nextPut: $(; nextPutAll: self class name;
		nextPutAll: ' inf: '; store: inf ;
		nextPutAll: ' sup: '; store: sup;
		nextPut: $)! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 11/8/2014 08:07'!
sup
^sup! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 12/13/2014 16:48'!
sup: aNumber
"if aNumber < inf then an empty RealInterval will be returned"
^sup:= inf 
	ifNil: [ inf:=aNumber ] 
	ifNotNil: [inf isNaN 
		ifTrue: [aNumber isInfinite 
			ifTrue: [ (aNumber >0)
				ifTrue: [ inf:= 0-Float infinity. Float infinity ] 
				ifFalse:  [ inf:= Float nan ] ] 
			ifFalse:[inf:=aNumber] ] 
		ifFalse:[ ((aNumber >=inf)and:[aNumber > Float infinity negated ]) ifTrue: [ aNumber ] ifFalse:[inf:= Float nan]]] .! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'wernerkassens 3/11/2015 21:13'!
tan
"this operator can be extremely problematic if one boundary is very near a multiple of halfPi and correcting that would be complicated, as for example:
Float halfPi tan. -->8.165889364191922e15
of course this not surprising at all, as halfPi is only an approximation of half Pi, obviously at the lower side. but what surprised me was this:
Float halfPi successor tan. -->8.165889364191922e15
i needed to do this to get a high negative number:
Float halfPi successor successor tan. -->-3.1091764830118915e15
this happens because #cos reacts in the same way and i found this behaviour of #cos so annoying and in a way buggy (of course one can argue, that it is a simple Floating Point Error that one can get a positive almost-infinity instead of a negative almost-infinity, but i would nevertheless expect a more rational behaviour of #cos in the range of -2 Pi to 2 Pi) that i simply ignored the whole problem. well ok, it _is_ a simple Floating Point Error, but i find it somewhat annoying nevertheless"
|l u|
self isEmpty ifTrue: [ ^RealInterval new ].
self width >= Float pi ifTrue: [ ^RealInterval entire ].
l:=inf\\Float pi.
u:=sup\\Float pi.
^l=u 
	ifTrue: [l=Float halfPi 
		ifTrue: [ RealInterval entire "well halfPi is only approximately half Pi, an interval should be used" ] 
		ifFalse:  [RealInterval fromNumber: l tan] ] 
	ifFalse: [ l<u 
		ifTrue: [ (Float halfPi between: l and: u)
			ifTrue:[ l=Float halfPi 
				ifTrue: [ RealInterval inf: Float infinity negated  sup: u tan ] 
				ifFalse:[u=Float halfPi 
					ifTrue: [ RealInterval inf: l tan sup: Float infinity ] 
					ifFalse: [(RealInterval inf: l tan sup: Float infinity )union: (RealInterval inf: Float infinity negated  sup: u tan )]]]
			 ifFalse: [ RealInterval inf: l tan sup: u tan ] ] 
		ifFalse: [(Float halfPi between: u and: l)
			ifTrue: [ l=Float halfPi 
				ifTrue: [ RealInterval inf: u tan sup: Float infinity ] 
				ifFalse:[ u=Float halfPi 
					ifTrue:  [ RealInterval inf: Float infinity negated tan sup: l tan ]
					ifFalse: [ u tan hull: l tan ]]]
			ifFalse: [ (RealInterval inf: u tan sup: Float infinity )union: (RealInterval inf: Float infinity negated  sup: l tan ) ] ]]
! !

!RealInterval methodsFor: 'mathematical functions' stamp: 'WernerKassens 2/17/2016 19:09'!
tanh
^ self class inf: inf tanh sup: sup tanh! !

!RealInterval methodsFor: 'truncation' stamp: 'wernerkassens 1/15/2015 14:09'!
truncated
|i|
self isEmpty ifTrue: [ ^RealInterval new ].
i:=self isFinite  
	ifTrue: [ IntervalUnion withAll: (inf truncated to: sup truncated) ] 
	ifFalse:[( i:= inf isInfinite 
		ifTrue:  [ self copy sup: (self sup isInfinite ifTrue: [ sup ] ifFalse:[ sup truncated]); yourself ]
		ifFalse: [ self copy inf: self inf truncated; yourself ]) comments:'onlyIntegers'; yourself ].
^(i isIntervalUnion and: [i size=1]) ifTrue: [ i first ] ifFalse: [ i ]
! !

!RealInterval methodsFor: 'set operations' stamp: 'wernerkassens 1/15/2015 14:09'!
union: anInt 
(anInt isNumber and:[anInt isRealInterval not]) ifTrue: [^self union: (RealInterval fromNumber: anInt) ] .
self isEmpty ifTrue: [^anInt ].
anInt isEmpty ifTrue: [^self ].
anInt isIntervalUnion ifTrue: [ ^anInt union:self ].
(inf> anInt sup) ifTrue: [^IntervalUnion  with: anInt with: self ].
anInt inf >sup ifTrue:[^IntervalUnion with: self with:anInt ].
^RealInterval inf: (inf min: anInt inf) sup:(anInt sup max: sup)
! !

!RealInterval methodsFor: 'accessing' stamp: 'wernerkassens 12/22/2014 19:11'!
width
^sup-inf! !

Object subclass: #RealIntervalSetting
	instanceVariableNames: ''
	classVariableNames: 'EnableRealInterval'
	poolDictionaries: ''
	category: 'Math-RealInterval-Setting'!

!RealIntervalSetting commentStamp: 'WernerKassens 9/14/2017 16:14' prior: 0!
manages the overwriting ond restoring  of these standard pharo messages: 
Number>>raisedTo:
Number>>raisedToInteger:
Float>>/ 	 or  SmallFloat64>>/  and  BoxedFloat64>>/ 
Integer>>//
SmallInteger>>quo:
Fraction>>raisedToInteger:!

!RealIntervalSetting class methodsFor: 'accessing' stamp: 'wernerkassens 9/23/2017 15:26'!
enableCalculation
^EnableRealInterval ifNil:[EnableRealInterval:=false]! !

!RealIntervalSetting class methodsFor: 'accessing' stamp: 'wernerkassens 10/26/2017 12:00'!
enableCalculation: aBoolean
	self enableCalculation = aBoolean
		ifTrue: [ ^ aBoolean ].
	Author
		useAuthor: 'PMRISetting'
		during: [ aBoolean
				ifTrue: [ (RuleReplaceEqual0 new runOnEnvironment: self environment1) builder changes
						do: [ :change | change execute ].
					(RuleAddTest new runOnEnvironment: self environment2) builder changes
						do: [ :change | change execute ] ]
				ifFalse: [ self returnToOriginal ] ].
	^ EnableRealInterval := aBoolean! !

!RealIntervalSetting class methodsFor: 'accessing' stamp: 'wernerkassens 9/15/2017 18:00'!
environment1
	"for RuleReplaceEqual0 & RuleReplaceIsZero "

	| env |
	env := RBSelectorEnvironment new.
	(SystemVersion current major < 5 or: [ Smalltalk vm isSpur not ])
		ifTrue: [ env addMethod: Float >> #/ ]
		ifFalse: [ env
				addClass: #'SmallFloat64' asClass selector: #/;
				addClass: #'BoxedFloat64' asClass selector: #/ ].
	env addClass: SmallInteger selector: #quo:.
	^ env! !

!RealIntervalSetting class methodsFor: 'accessing' stamp: 'wernerkassens 9/23/2017 07:15'!
environment2
	"for RuleAddTest & RuleDeleteTest"

	| env |
	(env := RBSelectorEnvironment onMethods: #(#raisedTo: #raisedToInteger:) forClass: Number)
		addMethod: Integer >> #//;
		addMethod: Fraction >> #raisedToInteger:.
	^ env! !

!RealIntervalSetting class methodsFor: 'setting' stamp: 'WernerKassens 6/14/2017 04:15'!
realIntervalSettingsOn: aBuilder
<systemsettings>
(aBuilder group: #realInterval)
label: 'RealInterval';
with:[(aBuilder setting: #enableCalculation) 
		label: 'enable RealInterval calculations';
		description: 'needs to be checked for RealInterval calculations, but overwrites some standard Pharo methods which normally is not dangerous. If it gets unchecked the original implementations are restored.' ]! !

!RealIntervalSetting class methodsFor: 'private' stamp: 'wernerkassens 9/17/2017 14:40'!
returnToOriginal
	(RuleReplaceIsZero new runOnEnvironment: self environment1)
		builder changes do: [ :change | change execute ].
	(RuleDeleteTest new runOnEnvironment: self environment2)
		builder changes do: [ :change | change execute ].
	EnableRealInterval := false! !

Heap subclass: #IntervalHeap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-RealInterval-utils'!

!IntervalHeap commentStamp: 'wernerkassens 1/24/2015 18:36' prior: 0!
An IntervalHeap is a queue for the Skelboe-Moore algo
!

!IntervalHeap class methodsFor: 'instance creation' stamp: 'wernerkassens 2/27/2015 17:27'!
new
"just for internal use, use newQueue instead!!"
	^self new: 100! !

!IntervalHeap class methodsFor: 'instance creation' stamp: 'wernerkassens 1/27/2015 15:08'!
newQueue
^self sortBlock: [ :a :b|
	(a at:2)inf <= (b at:2)inf]! !

!IntervalHeap methodsFor: 'growing' stamp: 'wernerkassens 1/27/2015 15:20'!
growSize
	"Return the size by which the receiver should grow if there are no empty slots left."
	^50! !

!IntervalHeap methodsFor: 'private' stamp: 'wernerkassens 1/27/2015 15:28'!
updateObjectIndex: index
"is not necessary here"! !

RealInterval initialize!

BoxSplicing initialize!
